<?php

namespace App\Controllers;

use App\Models\Common_model;

class organization_admin extends BaseController
{
    public $session;
    public function __construct()
    {
        helper(['form','formatter']);
        $this->session = \Config\Services::session();
        $session = \Config\Services::session();
        if (!isset($_SESSION['uid'])) {
            $base_url = base_url('api/public/index.php/frontend/login');
            return redirect()->to($base_url);
        }
    }

    public function dashboard(){
        check_login();
        $data['title'] = 'Home';
        $data['manage_title'] = '';
        $data['main_page'] = 'api/public/index.php/organization_admin/dashboard';
        $data['current_page'] = 'api/public/index.php/organization_admin/dashboard';
        $data['is_dashboard'] = 1;

        return view('org_admin/dashboard', $data);
    }

    public function add_group(){
        check_login();
        $allowed_total_user = get_organisation_total_users_count($_SESSION['uid']);
        $org_admin_access_data = $_SESSION['org_admin_access_data'];
        if(isset($org_admin_access_data) && ($org_admin_access_data->is_allow_org_structure==0 || $org_admin_access_data->org_duration_date < date('Y-m-d') || $org_admin_access_data->org_allow_no_of_user <= $allowed_total_user)){
            $base_url = base_url('api/public/index.php/organization_admin/no_access');
            return redirect()->to($base_url);
        }
        $data['title'] = 'Add Group';
        $data['manage_title'] = 'Group';
        $data['main_page'] = 'api/public/index.php/frontend/front_dashboard';
        $data['list_page'] = 'api/public/index.php/organization_admin/list_group';
        $data['current_page'] = 'api/public/index.php/organization_admin/add_group';
        $data['form_action'] = 'api/public/index.php/organization_admin/create_group';

        $data['check_email_existence_url_group_tbl'] = 'api/public/index.php/organization_admin/check_email_existence_group_tbl';

        $data['check_mobile_no_existence_url_group_tbl'] = 'api/public/index.php/organization_admin/check_mobile_no_existence_group_tbl';

        return view('org_admin/add_group', $data);
    }

    public function create_group(){
        check_login();
        if($this->request->getMethod() == 'post') {
            $p = $this->request->getPost();
            $org_admin_id = isset($_SESSION['org_admin_id']) && !empty($_SESSION['org_admin_id']) ? $_SESSION['org_admin_id'] : $_SESSION['uid'];
            $db = db_connect();
            $checkEmailUser = "SELECT id FROM sq_user WHERE email = '{$p['email']}' AND trash_status <> 1 ";
            $resCheckEmailUser = $db->query($checkEmailUser);
            $rowEmailUser = $resCheckEmailUser->getRow();
            
            $mst_company_group_name_tbl = $db->table('mst_company_group_name');
            $mst_company_group_name_data = [
                'group_name' => $p['group_name'],
                // 'administrator_name' => $p['administrator_name'],
                // 'email' => strtolower($p['email']),
                // 'contact_number' => $p['contact_number'],
                'org_admin_id' => $org_admin_id,
                'addedby' => $_SESSION['uid']
            ];
            
            $mst_company_group_name_tbl->insert($mst_company_group_name_data);
            $last_insert_group_id = $db->insertID();
            
            if (empty($rowEmailUser)) {
                $last_insert_group_id = $db->insertID();
                
                $groupFirstFour = ucfirst(substr($p['group_name'], 0, 4));
                $mobileNoLastFour = substr($p['contact_number'], -4);
                $password = $groupFirstFour . $mobileNoLastFour;
                $authority_data = $this->get_parent_user_authority($_SESSION['uid']);
                if(!empty($authority_data)){
                    $no_of_seek_feedback_allowed = $authority_data->no_of_seek_feedback_allowed;
                    $sq_detailed_assessment = $authority_data->sq_detailed_assessment;
                    $sup_org_admin_id = $authority_data->sup_org_admin_id;
                }else{
                    $no_of_seek_feedback_allowed = 0;
                    $sq_detailed_assessment = 0;
                    $sup_org_admin_id = 0;
                }
                
                
                //if($emailsend){    
                    $sq_user_tbl = $db->table('sq_user');
                    $sq_user_data = [
                        'username' => strtolower($p['administrator_name']),
                        'password' => md5($password),
                        'email' => strtolower($p['email']),
                        'full_name' => ucwords(strtolower($p['administrator_name'])),
                        'account_type_id' => 2,
                        'group_ids' => 2,
                        'user_token' => 'logout-' . time(),
                        'trash_status' => '',
                        'created_time' => date('Y-m-d H:i:s'),
                        'token' => '',
                        'hash_token' => '',
                        'master_journeys_allowed' => '',
                        'child_journeys_allowed' => '',
                        'no_of_seek_feedback_allowed' => $no_of_seek_feedback_allowed,
                        'sq_detailed_assessment' => $sq_detailed_assessment,
                        'mobile' => $p['contact_number'],
                        'gender' => '',
                        'organisation_name' => '',
                        'company_group_id' => $last_insert_group_id,
                        'company_id' => 0,
                        'unit_id' => 0,
                        // 'role_id' => 1,
                        'is_team_member' => 0,
                        'parent_team_member' => $org_admin_id,
                        'is_group_admin' => 1,
                        'is_active' => 1,
                        'addedby'=>$_SESSION['uid'],
                        'is_allow_org_structure'=>0,
                        'is_allow_org_assesment'=>0,
                        'is_allow_team_assesment'=>1,
                        'sup_org_admin_id'=>(isset($_SESSION['is_sup_org_admin'])==1 ? $_SESSION['uid'] : $sup_org_admin_id),
                        'is_sup_org_admin'=>0
                    ];
                    
                    if($sq_user_tbl->insert($sq_user_data)) {
                        $last_insert_user_id = $db->insertID();
                        $user_group_company_unit_tbl = $db->table('user_group_company_unit');
                        $user_group_company_unit_data = [
                            'user_id' => $last_insert_user_id,
                            'group_id' => $last_insert_group_id,
                            'company_id' => 0,
                            'unit_id' => 0,
                            'is_group_admin'=>1,
                            'is_company_admin'=>0,
                            'is_team_member'=>0,
                            'role_id'=>0
                        ];
                        $user_group_company_unit_tbl->insert($user_group_company_unit_data);
                        //$sq_user_tbl->insert($sq_user_data);
                    }else{
                        session()->setFlashdata('message', 'Data not saved');
                        session()->setFlashdata('alert-class', 'alert-danger');
                    }
                    // if (!isset($p['add_group_ajax'])) {
                    //     $base_url = base_url('api/public/index.php/organization_admin/list_group');
                    //     return redirect()->to($base_url);                    
                    // }
                    // }else{
                    //     session()->setFlashdata('message', 'Please Enter The Valid Email Address');
                    //     session()->setFlashdata('alert-class', 'alert-danger');
                    // }
                
                $common_model = new Common_model();
                $subject = 'Welcome To MIJS';
                $added_by_name = $_SESSION['full_name'];
                $loginUrl = base_url('api/public/index.php/frontend/login');
                $emailsend = $common_model->send_welcome_mail_on_org_master_add($p['administrator_name'], $p['email'], $subject, $loginUrl, $password, $added_by_name, ucfirst($p['group_name']));
                
            }else{
                $user_group_company_unit_tbl = $db->table('user_group_company_unit');
                $user_group_company_unit_data = [
                    'user_id' => $rowEmailUser->id,
                    'group_id' => $last_insert_group_id,
                    'company_id' => 0,
                    'unit_id' => 0,
                    'is_group_admin'=>1,
                    'is_company_admin'=>0,
                    'is_team_member'=>0,
                    'role_id'=>0
                ];

                if ($user_group_company_unit_tbl->insert($user_group_company_unit_data)) {
                    session()->setFlashdata('message', 'Group added successfully');
                    session()->setFlashdata('alert-class', 'alert-success');
                }else{
                    session()->setFlashdata('message', 'Data not saved');
                    session()->setFlashdata('alert-class', 'alert-danger');
                }
            }
            if(isset($p['add_group_ajax']) && $p['add_group_ajax']) {
                $getGroup = "SELECT id, group_name
                        FROM mst_company_group_name
                        WHERE trash_status = 0 AND org_admin_id = $org_admin_id
                        ORDER BY group_name";
                $resGroup = $db->query($getGroup);
                $data = $resGroup->getResult();
                if ($data) {
                    echo json_encode(['status' => 'success', 'msg' => 'Group added successfully', 'res' => $data,'current_group_id'=>$last_insert_group_id]);
                } else {
                    echo json_encode(['status' => 'error', 'msg' => 'Data not saved']);
                }
            }else{
                session()->setFlashdata('message', 'Group added successfully');
                session()->setFlashdata('alert-class', 'alert-success');
                $base_url = base_url('api/public/index.php/organization_admin/list_group');
                return redirect()->to($base_url);
            }
        }
    }

    public function edit_group($id,$from_team_list=''){
        check_login();
        
        $data['from_team_list'] =$from_team_list;
        $data['group_id'] = $id;
        $data['title'] = 'Edit Group';
        $data['manage_title'] = 'Group';
        $data['main_page'] = 'api/public/index.php/frontend/front_dashboard';
        $data['list_page'] = 'api/public/index.php/organization_admin/list_group';
        $data['current_page'] = 'api/public/index.php/organization_admin/edit_group/' . $id;
        $data['form_action'] = 'api/public/index.php/organization_admin/update_group/' . $id;

        $data['check_email_existence_url_group_tbl'] = 'api/public/index.php/organization_admin/check_email_existence_group_tbl';

        $data['check_mobile_no_existence_url_group_tbl'] = 'api/public/index.php/organization_admin/check_mobile_no_existence_group_tbl';

        $org_admin_id = isset($_SESSION['org_admin_id']) && !empty($_SESSION['org_admin_id']) ? $_SESSION['org_admin_id'] : $_SESSION['uid'];

        $db = db_connect();

        // echo
        // $getGroup =
        //     "SELECT group_name, administrator_name, email, contact_number
        //                 FROM mst_company_group_name
        //                 WHERE id = $id 
        //                 AND trash_status = 0 
        //                 AND org_admin_id = $org_admin_id
        //                 ORDER BY group_name";
        // die;
        
        // echo
        $getGroup =
            "SELECT g.group_name, u.id AS user_id, u.full_name, u.email, u.mobile
                        FROM sq_user u
                        LEFT JOIN user_group_company_unit ugcu ON ugcu.user_id = u.id
                        LEFT JOIN mst_company_group_name g ON g.id = ugcu.group_id
                        WHERE g.id = $id 
                        AND g.trash_status = 0 
                        AND g.org_admin_id = $org_admin_id
                        AND u.is_active = 1
                        AND u.trash_status = 0
                        ";
        // die;

        $resGroup = $db->query($getGroup);
        $data['group_row'] = $resGroup->getRow();

        // echo "<pre>";print_r($data['group_row']);exit;
        return view('org_admin/add_group', $data);
    }

    public function update_group($id)
    {
        check_login();
        if ($this->request->getMethod() == 'post') {
            $p = $this->request->getPost();
            if($p['is_from_team_list']){
                $base_url = base_url('api/public/index.php/organization_admin/list_team_member');
            }else{
                $base_url = base_url('api/public/index.php/organization_admin/list_group');
            }
            $db = db_connect();
            
            // echo
            $checkEmailUser = "SELECT id FROM sq_user WHERE email = '{$p['email']}' AND trash_status <> 1 AND email <> '{$p['oldemail']}'";
            // die;
            $resCheckEmailUser = $db->query($checkEmailUser);
            $rowEmailUser = $resCheckEmailUser->getRow();
            if (empty($rowEmailUser)) {
                $sq_user_tbl = $db->table('sq_user');
                $group_name_data = [
                    'full_name' => $p['administrator_name'],
                    'email' => strtolower($p['email']),
                    'mobile' => $p['contact_number']
                ];
                $sq_user_tbl->where('email', $p['oldemail']);
                $sq_user_tbl->update($group_name_data);
                
            
            
                $mst_company_group_name_tbl = $db->table('mst_company_group_name');
                $mst_company_group_name_data = [
                    'group_name' => $p['group_name'],
                    // 'administrator_name' => $p['administrator_name'],
                    // 'email' => strtolower($p['email']),
                    // 'contact_number' => $p['contact_number']
                ];
                $mst_company_group_name_tbl->where('id', $id);
    
                if ($mst_company_group_name_tbl->update($mst_company_group_name_data)) {
                    session()->setFlashdata('message', 'Group updated successfully');
                    session()->setFlashdata('alert-class', 'alert-success');
                    return redirect()->to($base_url);
                } else {
                    session()->setFlashdata('message', 'Data not saved');
                    session()->setFlashdata('alert-class', 'alert-danger');
                    return redirect()->to($base_url);
                }
            }else {
                session()->setFlashdata('message', 'Data not saved');
                session()->setFlashdata('alert-class', 'alert-danger');
                return redirect()->to($base_url);
            }
        }
    }

    public function delete_group()
    {

        $p = $this->request->getPost();

        $db = db_connect();

        $builder = $db->table('mst_company_group_name');
        $builder->set('trash_status', 1);
        $builder->where('id', $p['group_id']);

        if ($builder->update()) {
            echo json_encode(['status' => 'success', 'msg' => 'Record deleted successfully.', 'url' => base_url('api/public/index.php/organization_admin/list_group')]);
        } else {

            echo json_encode(['status' => 'error', 'msg' => 'Record not deleted.']);
        }
    }

    public function list_group()
    {
        check_login();
        $allowed_total_user = get_organisation_total_users_count($_SESSION['uid']);
        $org_admin_access_data = $_SESSION['org_admin_access_data'];
        if(isset($org_admin_access_data) && $org_admin_access_data->is_allow_org_structure==1 && $org_admin_access_data->org_duration_date >= date('Y-m-d') && $org_admin_access_data->org_allow_no_of_user > $allowed_total_user){
            $data['add_url'] = 'api/public/index.php/organization_admin/add_group';
        }   
        $data['title'] = 'Group';
        $data['manage_title'] = '';
        $data['main_page'] = 'api/public/index.php/frontend/front_dashboard';
        $data['current_page'] = 'api/public/index.php/organization_admin/list_group';
        //$data['add_url'] = 'api/public/index.php/organization_admin/add_group';
        $data['get_list_data_url'] = 'get_list_group';
        $data['delete_url'] = 'delete_group';

        return view('org_admin/list_group', $data);
    }

    public function get_list_group()
    {
    
        $dtSearchColumns = array('group_name', 'administrator_name', 'email', 'contact_number');
        $DTRenderArray = $this->DT_Render_Columns($dtSearchColumns);
        $dtWhere = $DTRenderArray['dtWhere'];
        $dtOrder = $DTRenderArray['dtOrder'];
        $dtLimit = $DTRenderArray['dtLimit'];

        $DTRenderArray = $this->Load_Datatable_For_Group($dtWhere, $dtOrder, $dtLimit);

        $output = array(
            "sEcho" => $_GET['sEcho'] ? $_GET['sEcho'] : 0,
            "iTotalRecords" => $DTRenderArray['dtPerPageRecords'],
            "iTotalDisplayRecords" => $DTRenderArray['dtTotalRecords'],
            "aaData" => array()
        );
        // $dtDisplayColumns = array('id', 'addeddate', 'self_other', 'roles', 'Status', 'Actions');

        foreach ($DTRenderArray['ResultSet'] as $dtRow) {

            $row = [];

            $editBtn = '<a class="mr-2 close-icon tooltip-btn " href="' . base_url('api/public/index.php/organization_admin/edit_group/' . $dtRow->id) . '"><img src="' . base_url("new_frontend_assets/images/edit-icon.png") . '" alt=""> <span class="tooltiptext02">Edit</span></a>';

            $deleteBtn = '<a data-id="' . $dtRow->id . '" class="delete-btn close-icon tooltip-btn " href="#"><img src="' . base_url("new_frontend_assets/images/delete-icon.png") . '" alt=""> <span class="tooltiptext02">Delete</span></a>';

            $actionBtn = "<div class='btn-group'>$editBtn $deleteBtn</div>";

            $row[] = $dtRow->group_name;
            $row[] = $dtRow->full_name;
            $row[] = $dtRow->email;
            $row[] = $dtRow->mobile;
            $row[] = $actionBtn;

            $output['aaData'][] = $row;
        }

        echo json_encode($output);
    }

    public function Load_Datatable_For_Group($dtWhere, $dtOrder, $dtLimit){
        $org_admin_id = isset($_SESSION['org_admin_id']) && !empty($_SESSION['org_admin_id']) ? $_SESSION['org_admin_id'] : $_SESSION['uid'];
        $db = db_connect();
        if(isset($_SESSION['sup_org_admin_id']) && $_SESSION['sup_org_admin_id']==0){
            $where2 = ' AND g.addedby ='.$_SESSION['uid'];
        }else if(isset($_SESSION['org_admin_id']) && $_SESSION['org_admin_id']==0){
            $where2 = 'AND u.parent_team_member='.$_SESSION['uid'];
        }
        // else{
        //     $where2 = ' AND g.addedby ='.$_SESSION['uid'];
        // }
        
        $getResult = "SELECT  g.group_name, g.id, u.full_name, u.email, u.mobile
                        FROM sq_user u
                        LEFT JOIN user_group_company_unit ugcu ON ugcu.user_id = u.id AND ugcu.is_group_admin=1
                        LEFT JOIN mst_company_group_name g ON g.id = ugcu.group_id
                        WHERE g.trash_status = 0 
                        $dtWhere $where2
                        ORDER BY id DESC
                        $dtLimit ";
                        
        $resResult = $db->query($getResult);
        $result = $resResult->getResult();

        /*$getAllCount = "SELECT count(g.id) AS total 
                        FROM sq_user u
                        LEFT JOIN user_group_company_unit ugcu ON ugcu.user_id = u.id AND ugcu.is_group_admin=1
                        LEFT JOIN mst_company_group_name g ON g.id = ugcu.group_id
                        WHERE g.trash_status = 0 
                        AND u.is_group_admin=1
                        AND g.org_admin_id = $org_admin_id
                        AND u.is_active = 1
                        AND u.trash_status = 0
                        $dtWhere ";*/
                        
        $getAllCount = "SELECT  count(g.id) AS total
                        FROM sq_user u
                        LEFT JOIN user_group_company_unit ugcu ON ugcu.user_id = u.id AND ugcu.is_group_admin=1
                        LEFT JOIN mst_company_group_name g ON g.id = ugcu.group_id
                        WHERE g.trash_status = 0 
                        $dtWhere $where2
                        ORDER BY g.id DESC
                        $dtLimit ";                

        $getCount = $db->query($getAllCount);
        $resCount = $getCount->getResult();

        $data['ResultSet'] = $result;
        $data['dtPerPageRecords'] = count($data['ResultSet']);

        $data['dtTotalRecords'] = $resCount[0]->total;
        return $data;
    }

    public function add_company()
    {
        check_login();
        $allowed_total_user = get_organisation_total_users_count($_SESSION['uid']);
        $org_admin_access_data = $_SESSION['org_admin_access_data'];
        if(isset($org_admin_access_data) && ($org_admin_access_data->is_allow_org_structure==0 || $org_admin_access_data->org_duration_date < date('Y-m-d') || $org_admin_access_data->org_allow_no_of_user <= $allowed_total_user)){
            $base_url = base_url('api/public/index.php/organization_admin/no_access');
            return redirect()->to($base_url);
        }
        $data['title'] = 'Add Company';
        $data['manage_title'] = 'Company';
        $data['main_page'] = 'api/public/index.php/frontend/front_dashboard';
        $data['list_page'] = 'api/public/index.php/organization_admin/list_company';
        $data['current_page'] = 'api/public/index.php/organization_admin/add_company';
        $data['form_action'] = 'api/public/index.php/organization_admin/create_company';
        $data['add_group_ajax_url'] = 'api/public/index.php/organization_admin/create_group';

        $data['check_email_existence_url_group_tbl'] = 'api/public/index.php/organization_admin/check_email_existence_group_tbl';
        $data['check_email_existence_url_company_tbl'] = 'api/public/index.php/organization_admin/check_email_existence_company_tbl';

        $data['check_mobile_no_existence_url_group_tbl'] = 'api/public/index.php/organization_admin/check_mobile_no_existence_group_tbl';
        $data['check_mobile_no_existence_url_company_tbl'] = 'api/public/index.php/organization_admin/check_mobile_no_existence_company_tbl';
        
        $data['get_email_user_detail_url'] = 'api/public/index.php/organization_admin/get_email_user_detail';
        
        $org_admin_id = isset($_SESSION['org_admin_id']) && !empty($_SESSION['org_admin_id']) ? $_SESSION['org_admin_id'] : $_SESSION['uid'];

        $db = db_connect();

        // $getGroup = "SELECT id, group_name
        //                 FROM mst_company_group_name
        //                 WHERE trash_status = 0 
        //                 AND org_admin_id = $org_admin_id
        //                 ORDER BY group_name";
        
        // $getGroup = "SELECT g.id, g.group_name
        //                 FROM user_group_company_unit ugcu
        //                 LEFT JOIN mst_company_group_name g ON g.id = ugcu.group_id
        //                 WHERE g.trash_status = 0 
        //                 AND ugcu.user_id = {$_SESSION['uid']}
        //                 GROUP BY ugcu.group_id
        //                 ORDER BY g.group_name";
        if(isset($_SESSION['sup_org_admin_id']) && $_SESSION['sup_org_admin_id']==0){
            $where2 = 'AND g.addedby='.$_SESSION['uid'];
        }else{
            $where2 = ' AND g.addedby ='.$_SESSION['sup_org_admin_id'];
        }
        $getGroup = "SELECT g.id, g.group_name
                        FROM sq_user u 
                        LEFT JOIN  user_group_company_unit ugcu
                        ON u.id = ugcu.user_id  
                        LEFT JOIN mst_company_group_name g ON g.id = ugcu.group_id
                        WHERE g.trash_status = 0 
                        -- AND ugcu.user_id = {$_SESSION['uid']}
                        $where2
                        GROUP BY ugcu.group_id
                        ORDER BY g.group_name";  

        $resGroup = $db->query($getGroup);
        $data['group_list']  = $resGroup->getResult();

        return view('org_admin/add_company', $data);
    }

    public function create_company()
    {
        check_login();
        if ($this->request->getMethod() == 'post') {

            $p = $this->request->getPost();

            $org_admin_id = isset($_SESSION['org_admin_id']) && !empty($_SESSION['org_admin_id']) ? $_SESSION['org_admin_id'] : $_SESSION['uid'];
            $db = db_connect();
            
            $checkEmailUser = "SELECT id FROM sq_user WHERE email = '{$p['email']}' AND trash_status <> 1 ";
            $resCheckEmailUser = $db->query($checkEmailUser);
            $rowEmailUser = $resCheckEmailUser->getRow();

            $mst_company_name_tbl = $db->table('mst_company_name');
            $mst_company_name_data = [
                'company_group_id' => $p['company_group_id'],
                'company_name' => $p['company_name'],
                'company_location' => $p['company_location'],
                // 'administrator_name' => $p['administrator_name'],
                // 'email' => strtolower($p['email']),
                // 'contact_number' => $p['contact_number'],
                'org_admin_id' => $org_admin_id,
                'addedby' => $_SESSION['uid']
            ];
            $mst_company_name_tbl->insert($mst_company_name_data);
            $last_insert_company_id = $db->insertID();
            
            if (empty($rowEmailUser)) {

                $last_insert_company_id = $db->insertID();

                // echo
                $getGroup = "SELECT 
                    group_name,id,addedby
                    FROM mst_company_group_name
                    WHERE id = {$p['company_group_id']}
                    AND trash_status = 0 
                    AND org_admin_id = $org_admin_id
                    ";
                // die;

                $resGroup = $db->query($getGroup);
                $rowGroup = $resGroup->getRow();

                $companyFirstTwo = ucfirst(substr($p['company_name'], 0, 2));
                $groupFirstTwo = ucfirst(substr($rowGroup->group_name, 0, 2));
                $mobileNoLastFour = substr($p['contact_number'], -4);
                $password = $companyFirstTwo . $groupFirstTwo . $mobileNoLastFour;
                
                
                if(isset($_SESSION['is_group_admin']) && $_SESSION['is_group_admin']==1){
                    $group_admin_id=$_SESSION['uid'];
                }
                $authority_data = $this->get_parent_user_authority($_SESSION['uid']);
                if(!empty($authority_data)){
                    $no_of_seek_feedback_allowed = $authority_data->no_of_seek_feedback_allowed;
                    $sq_detailed_assessment = $authority_data->sq_detailed_assessment;
                    $sup_org_admin_id = $authority_data->sup_org_admin_id;
                }else{
                    $no_of_seek_feedback_allowed = 0;
                    $sq_detailed_assessment = 0;
                    $sup_org_admin_id = 0;
                }
                
                
                
                $grp_adm_data = $this->get_grp_admin_id($p['company_group_id']);
                if(!empty($grp_adm_data)){
                    $group_admin_id = $grp_adm_data->user_id;
                }else{
                    $group_admin_id = $rowCompany->group_admin_id;
                }
                
                $sq_user_tbl = $db->table('sq_user');
                $sq_user_data = [
                    'username' => strtolower($p['administrator_name']),
                    'password' => md5($password),
                    'email' => strtolower($p['email']),
                    'full_name' => ucwords(strtolower($p['administrator_name'])),
                    'account_type_id' => 2,
                    'group_ids' => 2,
                    'user_token' => 'logout-' . time(),
                    'trash_status' => '',
                    'created_time' => date('Y-m-d H:i:s'),
                    'token' => '',
                    'hash_token' => '',
                    'master_journeys_allowed' => '',
                    'child_journeys_allowed' => '',
                    'no_of_seek_feedback_allowed' => $no_of_seek_feedback_allowed,
                    'sq_detailed_assessment' => $sq_detailed_assessment,
                    'mobile' => $p['contact_number'],
                    'gender' => '',
                    'organisation_name' => '',
                    'company_group_id' => $p['company_group_id'],
                    'company_id' => $last_insert_company_id,
                    'unit_id' => 0,
                    // 'role_id' => 1,
                    'is_team_member' => 0,
                    'parent_team_member' => $org_admin_id,
                    'is_company_admin' => 1,
                    'is_active' => 1,
                    'group_admin_id'=>$group_admin_id,
                    'addedby'=>$_SESSION['uid'],
                    'is_allow_org_structure'=>1,
                    'is_allow_org_assesment'=>0,
                    'is_allow_team_assesment'=>1,
                    'sup_org_admin_id'=>(isset($_SESSION['is_sup_org_admin'])==1 ? $_SESSION['uid'] : $sup_org_admin_id),
                    'is_sup_org_admin'=>0
                ];

                if($sq_user_tbl->insert($sq_user_data)){
                    $last_insert_user_id = $db->insertID();
                    $user_group_company_unit_tbl = $db->table('user_group_company_unit');
                    $user_group_company_unit_data = [
                        'user_id' => $last_insert_user_id,
                        'group_id' => $p['company_group_id'],
                        'company_id' => $last_insert_company_id,
                        'unit_id' => 0,
                        'is_group_admin'=>0,
                        'is_company_admin'=>1,
                        'is_team_member'=>0,
                        'role_id'=>0
                    ];
                    $user_group_company_unit_tbl->insert($user_group_company_unit_data);
                    
                    $common_model = new Common_model();
                    $subject = 'Welcome To MIJS';
    
                    $added_by_name = $_SESSION['full_name'];
    
                    $loginUrl = base_url('api/public/index.php/frontend/login');
    
                    $common_model->send_welcome_mail_on_org_master_add($p['administrator_name'], $p['email'], $subject, $loginUrl, $password, $added_by_name, ucfirst($rowGroup->group_name), $p['company_name']);
    
                    
                } else {
                    session()->setFlashdata('message', 'Data not saved');
                    session()->setFlashdata('alert-class', 'alert-danger');
                }
                if (!isset($p['add_company_ajax'])) {
                    $base_url = base_url('api/public/index.php/organization_admin/list_company');
                    return redirect()->to($base_url);
                }
            }else {
                $user_group_company_unit_tbl = $db->table('user_group_company_unit');
                $user_group_company_unit_data = [
                    'user_id' => $rowEmailUser->id,
                    'group_id' => $p['company_group_id'],
                    'company_id' => $last_insert_company_id,
                    'unit_id' => 0,
                    'is_group_admin'=>0,
                    'is_company_admin'=>1,
                    'is_team_member'=>0,
                    'role_id'=>0
                ];

                if ($user_group_company_unit_tbl->insert($user_group_company_unit_data)) {
                    session()->setFlashdata('message', 'Group added successfully');
                    session()->setFlashdata('alert-class', 'alert-success');
                } else {
                    session()->setFlashdata('message', 'Data not saved');
                    session()->setFlashdata('alert-class', 'alert-danger');
                }
                if (!isset($p['add_company_ajax'])) {
                    $base_url = base_url('api/public/index.php/organization_admin/list_company');
                    return redirect()->to($base_url);
                }
            }
            if (isset($p['add_company_ajax']) && $p['add_company_ajax']) {
    
                $getCompany = "SELECT id, company_name
                    FROM mst_company_name
                    WHERE trash_status = 0 
                    AND org_admin_id = $org_admin_id
                    ORDER BY company_name";

                $resCompany = $db->query($getCompany);
                $data = $resCompany->getResult();

                if ($data) {

                    echo json_encode(['status' => 'success', 'msg' => 'Company added successfully', 'res' => $data,'current_company_id'=>$last_insert_company_id]);
                } else {

                    echo json_encode(['status' => 'error', 'msg' => 'Data not saved']);
                }
            } else {
                session()->setFlashdata('message', 'Company added successfully');
                session()->setFlashdata('alert-class', 'alert-success');

                $base_url = base_url('api/public/index.php/organization_admin/list_company');
                return redirect()->to($base_url);
            }
        }
    }

    public function edit_company($id,$from_team_list='')
    {
        check_login();
        $data['from_team_list'] =$from_team_list;
        $data['company_id'] = $id;
        $data['title'] = 'Edit Company';
        $data['manage_title'] = 'Company';
        $data['main_page'] = 'api/public/index.php/frontend/front_dashboard';
        $data['list_page'] = 'api/public/index.php/organization_admin/list_company';
        $data['current_page'] = 'api/public/index.php/organization_admin/edit_company/' . $id;
        $data['form_action'] = 'api/public/index.php/organization_admin/update_company/' . $id;

        $data['add_group_ajax_url'] = 'api/public/index.php/organization_admin/create_group';

        $data['check_email_existence_url_group_tbl'] = 'api/public/index.php/organization_admin/check_email_existence_group_tbl';
        $data['check_email_existence_url_company_tbl'] = 'api/public/index.php/organization_admin/check_email_existence_company_tbl';

        $data['check_mobile_no_existence_url_group_tbl'] = 'api/public/index.php/organization_admin/check_mobile_no_existence_group_tbl';
        $data['check_mobile_no_existence_url_company_tbl'] = 'api/public/index.php/organization_admin/check_mobile_no_existence_company_tbl';
        
        $data['get_email_user_detail_url'] = 'api/public/index.php/organization_admin/get_email_user_detail';

        $org_admin_id = isset($_SESSION['sup_org_admin_id']) && !empty($_SESSION['sup_org_admin_id']) ? $_SESSION['sup_org_admin_id'] : $_SESSION['uid'];

        $db = db_connect();

        $getGroup = "SELECT id, group_name
                        FROM mst_company_group_name
                        WHERE trash_status = 0 
                        AND org_admin_id = $org_admin_id
                        ORDER BY group_name
                    ";
        
        $resGroup = $db->query($getGroup);
        $data['group_list']  = $resGroup->getResult();

        $getCompany ="SELECT c.company_name,c.id,c.company_group_id,c.company_name,c.company_location, u.id AS user_id, u.full_name, u.email, u.mobile,ugcu.id as ugcu_id
                        FROM sq_user u
                        LEFT JOIN user_group_company_unit ugcu ON ugcu.user_id=u.id 
                        LEFT JOIN mst_company_name c ON c.id = ugcu.company_id
                        WHERE c.id = $id 
                        AND ugcu.is_company_admin = 1
                        AND ugcu.company_id=$id
                        AND c.trash_status = 0 
                        
                        AND u.is_active = 1
                        AND u.trash_status = 0
                        ";
        // die;
        // AND c.org_admin_id = $org_admin_id
        $resCompany = $db->query($getCompany);
        $data['company_row'] = $resCompany->getRow();

        return view('org_admin/add_company', $data);
    }

    public function update_company($id){
        if ($this->request->getMethod() == 'post') {
            $p = $this->request->getPost();
            if($p['is_from_team_list']){
                $base_url = base_url('api/public/index.php/organization_admin/list_team_member');
            }else{
                $base_url = base_url('api/public/index.php/organization_admin/list_company');
            }
            $db = db_connect();
            
            $checkEmailUser = "SELECT id FROM sq_user WHERE email = '{$p['email']}' AND trash_status <> 1 AND email <> '{$p['oldemail']}'";
            // die;
            $resCheckEmailUser = $db->query($checkEmailUser);
            $rowEmailUser = $resCheckEmailUser->getRow();
            if (empty($rowEmailUser)) {
                $sq_user_tbl = $db->table('sq_user');
                $cmp_name_data = [
                    'full_name' => $p['administrator_name'],
                    'email' => strtolower($p['email']),
                    'mobile' => $p['contact_number']
                ];
                $sq_user_tbl->where('email', $p['oldemail']);
                $sq_user_tbl->update($cmp_name_data);
            
                $mst_company_name_tbl = $db->table('mst_company_name');
                $mst_company_name_data = [
                    'company_group_id' => $p['company_group_id'],
                    'company_name' => $p['company_name'],
                    'company_location' => $p['company_location'],
                    // 'administrator_name' => $p['administrator_name'],
                    // 'email' => strtolower($p['email']),
                    // 'contact_number' => $p['contact_number']
                ];
    
                $mst_company_name_tbl->where('id', $id);
    
                if ($mst_company_name_tbl->update($mst_company_name_data)) {
                    
                    
                    $user_group_company_unit_tbl = $db->table('user_group_company_unit');
                    $user_group_company_unit_data = [
                        'group_id' => $p['company_group_id'],
                        'company_id' => $id,
                    ];
                    $user_group_company_unit_tbl->where('id', $p['ugcu_id']);
                    $user_group_company_unit_tbl->update($user_group_company_unit_data);
    
                    session()->setFlashdata('message', 'Company updated successfully');
                    session()->setFlashdata('alert-class', 'alert-success');
                    return redirect()->to($base_url);
                } else {
    
                    session()->setFlashdata('message', 'Data not saved');
                    session()->setFlashdata('alert-class', 'alert-danger');
                    return redirect()->to($base_url);
                }
            }else{
                session()->setFlashdata('message', 'Company updated successfully');
                session()->setFlashdata('alert-class', 'alert-success');
                return redirect()->to($base_url);
            }
        }
    }

    public function delete_company()
    {

        $p = $this->request->getPost();

        $db = db_connect();

        $builder = $db->table('mst_company_name');
        $builder->set('trash_status', 1);
        $builder->where('id', $p['company_id']);

        if ($builder->update()) {
            echo json_encode(['status' => 'success', 'msg' => 'Record deleted successfully.', 'url' => base_url('api/public/index.php/organization_admin/list_company')]);
        } else {

            echo json_encode(['status' => 'error', 'msg' => 'Record not deleted.']);
        }
    }

    public function list_company()
    { 
        check_login();
        $allowed_total_user = get_organisation_total_users_count($_SESSION['uid']);
        $org_admin_access_data = $_SESSION['org_admin_access_data'];
        if(isset($org_admin_access_data) && $org_admin_access_data->is_allow_org_structure==1 && $org_admin_access_data->org_duration_date >= date('Y-m-d') && $org_admin_access_data->org_allow_no_of_user > $allowed_total_user){
            $data['add_url'] = 'api/public/index.php/organization_admin/add_company';
        }
        $data['title'] = 'Company';
        $data['manage_title'] = '';
        $data['main_page'] = 'api/public/index.php/frontend/front_dashboard';
        $data['current_page'] = 'api/public/index.php/organization_admin/list_company';
        //$data['add_url'] = 'api/public/index.php/organization_admin/add_company';
        $data['get_list_data_url'] = 'get_list_company';
        $data['delete_url'] = 'delete_company';

        return view('org_admin/list_company', $data);
    }

    public function get_list_company()
    {
        
        $dtSearchColumns = array('company_name', 'group_name', 'administrator_name', 'email', 'contact_number');
        $DTRenderArray = $this->DT_Render_Columns($dtSearchColumns);
        $dtWhere = $DTRenderArray['dtWhere'];
        $dtOrder = $DTRenderArray['dtOrder'];
        $dtLimit = $DTRenderArray['dtLimit'];

        $DTRenderArray = $this->Load_Datatable_For_Company($dtWhere, $dtOrder, $dtLimit);

        $output = array(
            "sEcho" => $_GET['sEcho'] ? $_GET['sEcho'] : 0,
            "iTotalRecords" => $DTRenderArray['dtPerPageRecords'],
            "iTotalDisplayRecords" => $DTRenderArray['dtTotalRecords'],
            "aaData" => array()
        );

        foreach ($DTRenderArray['ResultSet'] as $dtRow) {

            $row = [];

            $editBtn = '<a class="mr-2 close-icon tooltip-btn " href="' . base_url('api/public/index.php/organization_admin/edit_company/' . $dtRow->id) . '"><img src="' . base_url("new_frontend_assets/images/edit-icon.png") . '" alt=""> <span class="tooltiptext02">Edit</span></a>';

            $deleteBtn = '<a data-id="' . $dtRow->id . '" class="delete-btn close-icon tooltip-btn " href="#"><img src="' . base_url("new_frontend_assets/images/delete-icon.png") . '" alt=""> <span class="tooltiptext02">Delete</span></a>';

            $actionBtn = "<div class='btn-group'>$editBtn $deleteBtn</div>";

            $row[] = $dtRow->group_name;
            $row[] = $dtRow->company_name;
            $row[] = $dtRow->full_name;
            $row[] = $dtRow->email;
            $row[] = $dtRow->mobile;
            $row[] = $actionBtn;

            $output['aaData'][] = $row;
        }

        echo json_encode($output);
    }

    public function Load_Datatable_For_Company($dtWhere, $dtOrder, $dtLimit){ 
        $org_admin_id = isset($_SESSION['sup_org_admin_id']) && !empty($_SESSION['sup_org_admin_id']) ? $_SESSION['sup_org_admin_id'] : $_SESSION['uid'];
        $db = db_connect();
        if(isset($_SESSION['is_sup_org_admin']) && $_SESSION['is_sup_org_admin']==0){
            $where2 = ' AND c.org_admin_id IN (SELECT id FROM sq_user where parent_team_member = '.$_SESSION['uid'].')';
        }else{
            $where2 = ' AND (c.addedby ='.$_SESSION['uid'].' OR c.addedby ='.$_SESSION['sup_org_admin_id'].')';
        }
        
         
         $getResult = "SELECT
                            c.id,
                            c.company_name,
                            g.group_name,
                            u.full_name,
                            u.email,
                            u.mobile
                        FROM
                            user_group_company_unit ugcu
                        LEFT JOIN sq_user u ON
                            ugcu.user_id = u.id
                        LEFT JOIN mst_company_group_name g ON
                            g.id = ugcu.group_id
                        LEFT JOIN mst_company_name c ON
                            c.id = ugcu.company_id
                        WHERE c.trash_status = 0
                        AND ugcu.is_company_admin = 1
                        
                        AND u.is_active = 1
                        AND u.trash_status = 0
                        $where2
                        $dtWhere
                        ORDER BY c.id DESC
                        $dtLimit
        ";
        // AND c.org_admin_id = $org_admin_id
        // die;
        

        $resResult = $db->query($getResult);
        $result = $resResult->getResult();

        
        $getAllCount = "SELECT
                            count(c.id) AS total 
                        FROM
                            user_group_company_unit ugcu
                        LEFT JOIN sq_user u ON
                            ugcu.user_id = u.id
                        LEFT JOIN mst_company_group_name g ON
                            g.id = ugcu.group_id
                        LEFT JOIN mst_company_name c ON
                            c.id = ugcu.company_id
                        WHERE c.trash_status = 0
                        AND ugcu.is_company_admin = 1
                        
                        AND u.is_active = 1
                        AND u.trash_status = 0
                        $where2
                        $dtWhere
                        ORDER BY c.id DESC
                        $dtLimit
                    ";
        

        $getCount = $db->query($getAllCount);
        $resCount = $getCount->getResult();

        $data['ResultSet'] = $result;
        $data['dtPerPageRecords'] = count($data['ResultSet']);

        $data['dtTotalRecords'] = $resCount[0]->total;
        return $data;
    }

    public function add_unit()
    {
        $data['title'] = 'Add Unit';
        $data['manage_title'] = 'Unit';
        $data['main_page'] = 'api/public/index.php/frontend/front_dashboard';
        $data['list_page'] = 'api/public/index.php/organization_admin/list_unit';
        $data['current_page'] = 'api/public/index.php/organization_admin/add_unit';
        $data['form_action'] = 'api/public/index.php/organization_admin/create_unit';
        $data['get_company_url'] = 'api/public/index.php/organization_admin/get_company';
        $data['get_parent_unit_url'] = 'api/public/index.php/organization_admin/get_parent_unit';

        $data['add_group_ajax_url'] = 'api/public/index.php/organization_admin/create_group';
        $data['add_company_ajax_url'] = 'api/public/index.php/organization_admin/create_company';

        $data['check_email_existence_url_group_tbl'] = 'api/public/index.php/organization_admin/check_email_existence_group_tbl';
        $data['check_email_existence_url_company_tbl'] = 'api/public/index.php/organization_admin/check_email_existence_company_tbl';

        $data['check_mobile_no_existence_url_group_tbl'] = 'api/public/index.php/organization_admin/check_mobile_no_existence_group_tbl';
        $data['check_mobile_no_existence_url_company_tbl'] = 'api/public/index.php/organization_admin/check_mobile_no_existence_company_tbl';

        
        $db = db_connect();
        // if(!isset($_SESSION['sup_org_admin_id']) && !empty($_SESSION['sup_org_admin_id'])){
        //     $where2 = 'AND g.addedby='.$_SESSION['uid'];
        // }else{
        //     $where2 = ' AND g.addedby ='.$_SESSION['sup_org_admin_id'];
        // }
        if(isset($_SESSION['org_admin_id']) && $_SESSION['org_admin_id']==0){
            $where2 = 'AND u.parent_team_member='.$_SESSION['uid'];
        }else{
            //$where2 = ' AND g.addedby ='.$_SESSION['uid'];
            $where2 = ' AND g.addedby ='.$_SESSION['sup_org_admin_id'];
        }
            
        $getGroup = "SELECT g.id, g.group_name
                        FROM sq_user u 
                        LEFT JOIN  user_group_company_unit ugcu
                        ON u.id = ugcu.user_id  
                        LEFT JOIN mst_company_group_name g ON g.id = ugcu.group_id
                        WHERE g.trash_status = 0 
                        -- AND ugcu.user_id = {$_SESSION['uid']}
                        $where2
                        GROUP BY ugcu.group_id
                        ORDER BY g.group_name";
        
        $resGroup = $db->query($getGroup);
        $data['group_list'] = $resGroup->getResult();

        if (isset($_SESSION['company_group_id'])) {

            $getCompany = "SELECT 
            c.id, c.company_name
            FROM mst_company_name c
            INNER JOIN mst_company_group_name cg ON cg.id = c.company_group_id
            WHERE cg.id = {$_SESSION['company_group_id']} AND c.trash_status = 0
            ORDER BY c.company_name
            ";

            $resCompany = $db->query($getCompany);
            $data['company_list'] = $resCompany->getResult();
        }
        if(isset($_SESSION['sup_org_admin_id']) && $_SESSION['sup_org_admin_id']==0){
            //$where2 = 'AND sup_org_admin_id='.$_SESSION['uid'];
            $where2 = 'AND org_admin_id='.$_SESSION['uid'];
        }else{
            $where2 = ' AND addedby ='.$_SESSION['sup_org_admin_id'];
        }
        $getUnit = "SELECT id, unit_name
                        FROM mst_unit
                        WHERE trash_status = 0 
                        AND parent_unit_id = 0 
                        $where2
                        ORDER BY unit_name";
        
        $resUnit = $db->query($getUnit);
        $data['unit_list'] = $resUnit->getResult();
        // $org_admin_id = isset($_SESSION['org_admin_id']) && !empty($_SESSION['org_admin_id']) ? $_SESSION['org_admin_id'] : $_SESSION['uid'];

        // $db = db_connect();

        // $getGroup = "SELECT g.id, g.group_name
        //                 FROM user_group_company_unit ugcu
        //                 LEFT JOIN mst_company_group_name g ON g.id = ugcu.group_id
        //                 WHERE g.trash_status = 0 
        //                 AND ugcu.user_id = {$_SESSION['uid']}
        //                 GROUP BY ugcu.group_id
        //                 ORDER BY g.group_name";

        // $resGroup = $db->query($getGroup);
        // $data['group_list']  = $resGroup->getResult();

        // $getCompany = "SELECT id, company_name
        //                 FROM mst_company_name
        //                 WHERE trash_status = 0 
        //                 AND org_admin_id = $org_admin_id
        //                 ORDER BY company_name";

        // $resGroup = $db->query($getCompany);
        // $data['company_list']  = $resGroup->getResult();
        
            
        // $getUnit = "SELECT id, unit_name
        //                 FROM mst_unit
        //                 WHERE trash_status = 0 
        //                 AND parent_unit_id = 0 
        //                 AND org_admin_id = $org_admin_id
        //                 ORDER BY unit_name";
        
        // $resUnit = $db->query($getUnit);
        // $data['unit_list']  = $resUnit->getResult();
        //echo "<pre>";print_r($data['unit_list']);exit;
        return view('org_admin/add_unit', $data);
    }

    public function create_unit()
    {
        if ($this->request->getMethod() == 'post') {
            $p = $this->request->getPost();
            $org_admin_id = isset($_SESSION['org_admin_id']) && !empty($_SESSION['org_admin_id']) ? $_SESSION['org_admin_id'] : $_SESSION['uid'];
            $db = db_connect();
            
            

            $mst_unit_tbl = $db->table('mst_unit');
            $mst_unit_data = [
                'company_group_id' => $p['company_group_id'],
                'company_id' => $p['company_id'],
                'unit_name' => $p['unit_name'],
                'unit_location' => $p['unit_location'],
                'parent_unit_id' => $p['parent_unit_id'],
                'org_admin_id' => $org_admin_id,
                'addedby' => $_SESSION['uid']
            ];
            $mst_unit_tbl->insert($mst_unit_data);
            $last_insert_unit_id = $db->insertID();
            if (!empty($last_insert_unit_id)) {

                if (isset($p['add_unit_ajax']) && $p['add_unit_ajax']) {

                    $company_group_id = $p['company_group_id'];
                    $company_id = $p['company_id'];

                    $org_admin_id = isset($_SESSION['org_admin_id']) && !empty($_SESSION['org_admin_id']) ? $_SESSION['org_admin_id'] : $_SESSION['uid'];

                    // echo
                    $getParentChildUnit = "SELECT un.parent_unit_id, un.id AS child_unit_id, un.unit_name AS child_unit_name
                                    FROM mst_unit un
                                    LEFT JOIN mst_unit un1 ON un1.id = un.parent_unit_id
                                    INNER JOIN mst_company_group_name g ON g.id = un.company_group_id
                                    INNER JOIN mst_company_name c ON c.id = un.company_id
                                    WHERE
                                    un.trash_status = 0
                                    AND un.org_admin_id = $org_admin_id
                                    
                                    AND g.trash_status = 0
                                    AND g.org_admin_id = $org_admin_id
                                    AND c.trash_status = 0
                                    AND c.org_admin_id = $org_admin_id
                                    AND un.company_group_id = $company_group_id
                                    AND un.company_id = $company_id
                                    ORDER BY child_unit_id, child_unit_name
                            ";


                    // $getParentChildUnit = "SELECT un1.id AS parent_unit_id, un.id AS child_unit_id, un1.unit_name AS parent_unit_name, un.unit_name AS child_unit_name
                    //                 FROM mst_unit un
                    //                 LEFT JOIN mst_unit un1 ON un1.id = un.parent_unit_id
                    //                 INNER JOIN mst_company_group_name g ON g.id = un.company_group_id
                    //                 INNER JOIN mst_company_name c ON c.id = un.company_id
                    //                 WHERE
                    //                 un.parent_unit_id != 0
                    //                 AND un.trash_status = 0
                    //                 AND un.org_admin_id = $org_admin_id
                    //                 AND un1.trash_status = 0
                    //                 AND un1.org_admin_id = $org_admin_id
                    //                 AND g.trash_status = 0
                    //                 AND g.org_admin_id = $org_admin_id
                    //                 AND c.trash_status = 0
                    //                 AND c.org_admin_id = $org_admin_id
                    //                 AND un.company_group_id = $company_group_id
                    //                 AND un.company_id = $company_id
                    //                 ORDER BY parent_unit_name, child_unit_name
                    //         ";        
                    // die;

                    $resParentChildUnit = $db->query($getParentChildUnit);
                    $parent_child_unit = $resParentChildUnit->getResult();

                    // $parent_child_unit_arr = [];
                    // foreach ($parent_child_unit as $v) {
                    //     $parent_child_unit_arr[$v->parent_unit_name][$v->child_unit_id] = $v->child_unit_name;
                    // }

                    echo json_encode(['status' => 'success', 'msg' => 'Unit added successfully', 'parent_child_unit_arr' => $parent_child_unit,'current_unit_id'=>$last_insert_unit_id]);
                } else {
                    session()->setFlashdata('message', 'Unit added successfully');
                    session()->setFlashdata('alert-class', 'alert-success');

                    $base_url = base_url('api/public/index.php/organization_admin/list_unit');
                    return redirect()->to($base_url);
                }
            } else {

                session()->setFlashdata('message', 'Data not saved');
                session()->setFlashdata('alert-class', 'alert-danger');
                if (!isset($p['add_unit_ajax'])) {
                    $base_url = base_url('api/public/index.php/organization_admin/list_unit');
                    return redirect()->to($base_url);
                }else{
                    $company_group_id = $p['company_group_id'];
                    $company_id = $p['company_id'];

                    $org_admin_id = isset($_SESSION['org_admin_id']) && !empty($_SESSION['org_admin_id']) ? $_SESSION['org_admin_id'] : $_SESSION['uid'];

                    // echo
                    $getParentChildUnit = "SELECT un.parent_unit_id, un.id AS child_unit_id, un.unit_name AS child_unit_name
                                    FROM mst_unit un
                                    LEFT JOIN mst_unit un1 ON un1.id = un.parent_unit_id
                                    INNER JOIN mst_company_group_name g ON g.id = un.company_group_id
                                    INNER JOIN mst_company_name c ON c.id = un.company_id
                                    WHERE
                                    un.trash_status = 0
                                    AND un.org_admin_id = $org_admin_id
                                    
                                    AND g.trash_status = 0
                                    AND g.org_admin_id = $org_admin_id
                                    AND c.trash_status = 0
                                    AND c.org_admin_id = $org_admin_id
                                    AND un.company_group_id = $company_group_id
                                    AND un.company_id = $company_id
                                    ORDER BY child_unit_id, child_unit_name
                            ";
                    
                    $resParentChildUnit = $db->query($getParentChildUnit);
                    $parent_child_unit = $resParentChildUnit->getResult();

                    echo json_encode(['status' => 'success', 'msg' => 'Unit added successfully', 'parent_child_unit_arr' => $parent_child_unit,'current_unit_id'=>$last_insert_unit_id]);
                }
                
            }
        }
    }

    public function edit_unit($id)
    {
        check_login();
        $data['unit_id'] = $id;
        $data['title'] = 'Edit Unit';
        $data['manage_title'] = 'Unit';
        $data['main_page'] = 'api/public/index.php/frontend/front_dashboard';
        $data['list_page'] = 'api/public/index.php/organization_admin/list_unit';
        $data['current_page'] = 'api/public/index.php/organization_admin/edit_unit/' . $id;
        $data['form_action'] = 'api/public/index.php/organization_admin/update_unit/' . $id;
        $data['get_company_url'] = 'api/public/index.php/organization_admin/get_company';
        $data['get_parent_unit_url'] = 'api/public/index.php/organization_admin/get_parent_unit';

        $data['add_group_ajax_url'] = 'api/public/index.php/organization_admin/create_group';
        $data['add_company_ajax_url'] = 'api/public/index.php/organization_admin/create_company';

        $data['check_email_existence_url_group_tbl'] = 'api/public/index.php/organization_admin/check_email_existence_group_tbl';
        $data['check_email_existence_url_company_tbl'] = 'api/public/index.php/organization_admin/check_email_existence_company_tbl';

        $data['check_mobile_no_existence_url_group_tbl'] = 'api/public/index.php/organization_admin/check_mobile_no_existence_group_tbl';
        $data['check_mobile_no_existence_url_company_tbl'] = 'api/public/index.php/organization_admin/check_mobile_no_existence_company_tbl';

        $org_admin_id = isset($_SESSION['sup_org_admin_id']) && !empty($_SESSION['sup_org_admin_id']) ? $_SESSION['sup_org_admin_id'] : $_SESSION['uid'];

        $db = db_connect();

        // echo
        $getUnit = "SELECT * FROM mst_unit
            WHERE id = $id 
            AND trash_status = 0 
            AND org_admin_id = $org_admin_id
        ";
        // die;

        $resUnit = $db->query($getUnit);
        $data['unit_row'] = $resUnit->getRow();

        $getGroup = "SELECT id, group_name
                        FROM mst_company_group_name
                        WHERE trash_status = 0 
                        AND org_admin_id = $org_admin_id
                        ORDER BY group_name
                        ";

        $resGroup = $db->query($getGroup);
        $data['group_list']  = $resGroup->getResult();

        $getCompany = "SELECT id, company_name
                        FROM mst_company_name
                        WHERE trash_status = 0 
                        AND org_admin_id = $org_admin_id 
                        AND company_group_id = {$data['unit_row']->company_group_id}
                        ORDER BY company_name
                        ";

        $resCompany = $db->query($getCompany);
        $data['company_list'] = $resCompany->getResult();

        $getUnitList = "SELECT id, unit_name
                        FROM mst_unit
                        WHERE trash_status = 0 
                        AND parent_unit_id = 0 
                        AND org_admin_id = $org_admin_id 
                        AND company_group_id = {$data['unit_row']->company_group_id} 
                        -- AND company_id = {$data['unit_row']->company_id}
                        AND id !=$id
                        ORDER BY unit_name
                        ";

        $resUnitList = $db->query($getUnitList);
        $data['unit_list']  = $resUnitList->getResult();

        return view('org_admin/add_unit', $data);
    }

    public function update_unit($id)
    {
        if ($this->request->getMethod() == 'post') {

            $p = $this->request->getPost();

            $db = db_connect();

            $mst_unit_tbl = $db->table('mst_unit');

            $mst_unit_data = [
                'company_group_id' => $p['company_group_id'],
                'company_id' => $p['company_id'],
                'unit_name' => $p['unit_name'],
                'unit_location' => $p['unit_location'],
                'parent_unit_id' => $p['parent_unit_id']
            ];

            $mst_unit_tbl->where('id', $id);

            if ($mst_unit_tbl->update($mst_unit_data)) {

                session()->setFlashdata('message', 'Unit updated successfully');
                session()->setFlashdata('alert-class', 'alert-success');

                $base_url = base_url('api/public/index.php/organization_admin/list_unit');
                return redirect()->to($base_url);
            } else {

                session()->setFlashdata('message', 'Data not saved');
                session()->setFlashdata('alert-class', 'alert-danger');

                $base_url = base_url('api/public/index.php/organization_admin/list_unit');
                return redirect()->to($base_url);
            }
        }
    }

    public function delete_unit()
    {

        $p = $this->request->getPost();

        $db = db_connect();

        $builder = $db->table('mst_unit');
        $builder->set('trash_status', 1);
        $builder->where('id', $p['unit_id']);

        if ($builder->update()) {
            echo json_encode(['status' => 'success', 'msg' => 'Record deleted successfully.', 'url' => base_url('api/public/index.php/organization_admin/list_unit')]);
        } else {

            echo json_encode(['status' => 'error', 'msg' => 'Record not deleted.']);
        }
    }

    public function list_unit()
    {
        check_login();
        $data['title'] = 'Unit';
        $data['manage_title'] = '';
        $data['main_page'] = 'api/public/index.php/frontend/front_dashboard';
        $data['list_page'] = 'api/public/index.php/organization_admin/list_unit';
        $data['current_page'] = 'api/public/index.php/organization_admin/list_unit';
        $data['add_url'] = 'api/public/index.php/organization_admin/add_unit';
        $data['get_list_data_url'] = 'get_list_unit';
        $data['delete_url'] = 'delete_unit';

        return view('org_admin/list_unit', $data);
    }

    public function get_list_unit()
    {
        $dtSearchColumns = array('unit_name', 'unit_location', 'group_name', 'company_name');
        $DTRenderArray = $this->DT_Render_Columns($dtSearchColumns);
        $dtWhere = $DTRenderArray['dtWhere'];
        $dtOrder = $DTRenderArray['dtOrder'];
        $dtLimit = $DTRenderArray['dtLimit'];

        $DTRenderArray = $this->Load_Datatable_For_Unit($dtWhere, $dtOrder, $dtLimit);

        $output = array(
            "sEcho" => $_GET['sEcho'] ? $_GET['sEcho'] : 0,
            "iTotalRecords" => $DTRenderArray['dtPerPageRecords'],
            "iTotalDisplayRecords" => $DTRenderArray['dtTotalRecords'],
            "aaData" => array()
        );

        foreach ($DTRenderArray['ResultSet'] as $dtRow) {

            $row = [];

            $editBtn = '<a class="mr-2 close-icon tooltip-btn " href="' . base_url('api/public/index.php/organization_admin/edit_unit/' . $dtRow->id) . '"><img src="' . base_url("new_frontend_assets/images/edit-icon.png") . '" alt=""> <span class="tooltiptext02">Edit</span></a>';

            $deleteBtn = '<a data-id="' . $dtRow->id . '" class="delete-btn close-icon tooltip-btn " href="#"><img src="' . base_url("new_frontend_assets/images/delete-icon.png") . '" alt=""> <span class="tooltiptext02">Delete</span></a>';

            $actionBtn = "<div class='btn-group'>$editBtn $deleteBtn</div>";

            $row[] = $dtRow->parent_unit_id;
            $row[] = $dtRow->group_name;
            $row[] = $dtRow->company_name;
            $row[] = $dtRow->unit_name;
            $row[] = $dtRow->unit_location;
            $row[] = $actionBtn;

            $output['aaData'][] = $row;
        }

        echo json_encode($output);
    }

    public function Load_Datatable_For_Unit($dtWhere, $dtOrder, $dtLimit)
    {
        //echo "<pre>";print_r($_SESSION);exit;
        $org_admin_id = isset($_SESSION['sup_org_admin_id']) && !empty($_SESSION['sup_org_admin_id']) ? $_SESSION['sup_org_admin_id'] : $_SESSION['uid'];
        if(isset($_SESSION['sup_org_admin_id']) && !empty($_SESSION['sup_org_admin_id'])){
            if(isset($_SESSION['is_group_admin']) && !empty($_SESSION['is_group_admin'])){
                //$where2 = 'AND u.company_id = '.$_SESSION['company_id'];    
                $where2 = ''; 
            }else if(isset($_SESSION['is_company_admin']) && !empty($_SESSION['is_company_admin'])){
                $where2 = 'AND u.company_id = '.$_SESSION['company_id'];    
            }else{
                $where2 = '';    
            }
            
        }else{
            $where2 = '';
        }
        $db = db_connect();

        // AND c.org_admin_id = $org_admin_id
        $getResult = "SELECT u.id, u.parent_unit_id, u.unit_name,

                        IF(u.parent_unit_id = 0, u.unit_location, '-') unit_location,
                        IF(u.parent_unit_id = 0, g.group_name, '-') group_name,
                        IF(u.parent_unit_id = 0, c.company_name, '-') company_name

                        FROM
                            mst_unit AS u
                        LEFT JOIN mst_unit AS u1 ON u.parent_unit_id = u1.id
                        LEFT JOIN mst_company_group_name g ON g.id = u.company_group_id
                        LEFT JOIN mst_company_name c ON c.id = u.company_id
                        WHERE u.trash_status = 0 
                        AND u.org_admin_id = $org_admin_id
                        AND g.trash_status = 0
                        AND g.org_admin_id = $org_admin_id
                        AND c.trash_status = 0
                        
                        AND
                        u.parent_unit_id NOT IN 
                            (SELECT id 
                                FROM mst_unit 
                                WHERE trash_status = 1 
                            ) 
                        $dtWhere
                        $where2
                        GROUP BY
                            u.id
                        ORDER BY
                            IFNULL(u1.unit_name, u.unit_name),
                            COALESCE(u.parent_unit_id, u.id),
                            u.parent_unit_id != 0,
                            u.unit_name
                        $dtLimit
                    ";
        // die;

        $resResult = $db->query($getResult);
        $result = $resResult->getResult();

        // echo
        $getAllCount = "SELECT u.id
                        FROM
                            mst_unit AS u
                        LEFT JOIN mst_unit AS u1 ON u.parent_unit_id = u1.id
                        LEFT JOIN mst_company_group_name g ON g.id = u.company_group_id
                        LEFT JOIN mst_company_name c ON c.id = u.company_id
                        WHERE u.trash_status = 0 
                        AND u.org_admin_id = $org_admin_id
                        AND g.trash_status = 0
                        AND g.org_admin_id = $org_admin_id
                        AND c.trash_status = 0
                        AND c.org_admin_id = $org_admin_id
                        AND
                        u.parent_unit_id NOT IN 
                            (SELECT id 
                                FROM mst_unit 
                                WHERE trash_status = 1 
                            ) 
                        $dtWhere
                        GROUP BY
                            u.id
                        ORDER BY
                            IFNULL(u1.unit_name, u.unit_name),
                            COALESCE(u.parent_unit_id, u.id),
                            u.parent_unit_id != 0,
                            u.unit_name
                        ";
        // die;

        $getCount = $db->query($getAllCount);
        $resCount = $getCount->getResultArray();

        $data['ResultSet'] = $result;
        $data['dtPerPageRecords'] = count($data['ResultSet']);

        $data['dtTotalRecords'] = count($resCount);
        return $data;
    }

    public function add_team_member()
    {
        check_login();
        $allowed_total_user = get_organisation_total_users_count($_SESSION['uid']);
        $org_admin_access_data = $_SESSION['org_admin_access_data'];
        if(isset($org_admin_access_data) && ($org_admin_access_data->is_allow_org_structure==0 || $org_admin_access_data->org_duration_date < date('Y-m-d') || $org_admin_access_data->org_allow_no_of_user <= $allowed_total_user)){
            $base_url = base_url('api/public/index.php/organization_admin/no_access');
            return redirect()->to($base_url);
        }
        $data['title'] = 'Add Team';
        $data['manage_title'] = 'Org structure';
        $data['main_page'] = 'api/public/index.php/frontend/front_dashboard';
        $data['list_page'] = 'api/public/index.php/organization_admin/list_team_member';
        $data['current_page'] = 'api/public/index.php/organization_admin/add_team_member';
        $data['form_action'] = 'api/public/index.php/organization_admin/create_team_member';
        $data['get_company_url'] = 'api/public/index.php/organization_admin/get_company';
        $data['get_unit_url'] = 'api/public/index.php/organization_admin/get_unit';
        $data['get_parent_unit_url'] = 'api/public/index.php/organization_admin/get_parent_unit';

        $data['add_group_ajax_url'] = 'api/public/index.php/organization_admin/create_group';
        $data['add_company_ajax_url'] = 'api/public/index.php/organization_admin/create_company';
        $data['add_unit_ajax_url'] = 'api/public/index.php/organization_admin/create_unit';

        $data['check_email_existence_url_user_tbl'] = 'api/public/index.php/organization_admin/check_email_existence_user_tbl';
        $data['check_email_existence_url_group_tbl'] = 'api/public/index.php/organization_admin/check_email_existence_group_tbl';
        $data['check_email_existence_url_company_tbl'] = 'api/public/index.php/organization_admin/check_email_existence_company_tbl';

        $data['check_mobile_no_existence_url_user_tbl'] = 'api/public/index.php/organization_admin/check_mobile_no_existence_user_tbl';
        $data['check_mobile_no_existence_url_group_tbl'] = 'api/public/index.php/organization_admin/check_mobile_no_existence_group_tbl';
        $data['check_mobile_no_existence_url_company_tbl'] = 'api/public/index.php/organization_admin/check_mobile_no_existence_company_tbl';
        
        $data['get_email_user_detail_url'] = 'api/public/index.php/organization_admin/get_email_user_detail';

        $org_admin_id = isset($_SESSION['org_admin_id']) && !empty($_SESSION['org_admin_id']) ? $_SESSION['org_admin_id'] : $_SESSION['uid'];

        $db = db_connect();
        if(isset($_SESSION['sup_org_admin_id']) && $_SESSION['sup_org_admin_id']==0){
            $where2 = 'AND g.addedby='.$_SESSION['uid'];
        }else if(isset($_SESSION['org_admin_id']) && $_SESSION['org_admin_id']==0){
            $where2 = 'AND u.parent_team_member='.$_SESSION['uid'];
        }else{
            $where2 = ' AND g.addedby ='.$_SESSION['sup_org_admin_id'];
        }
            
        // $getGroup = "SELECT id, group_name
        //                 FROM mst_company_group_name
        //                 WHERE trash_status = 0 
        //                 AND org_admin_id = $org_admin_id
        //                 ORDER BY group_name";
        
        $getGroup = "SELECT g.id, g.group_name
                        FROM sq_user u 
                        LEFT JOIN  user_group_company_unit ugcu
                        ON u.id = ugcu.user_id  
                        LEFT JOIN mst_company_group_name g ON g.id = ugcu.group_id
                        WHERE g.trash_status = 0 
                        $where2
                        GROUP BY ugcu.group_id
                        ORDER BY g.group_name";
                        
        $resGroup = $db->query($getGroup);
        $data['group_list'] = $resGroup->getResult();

        if (isset($_SESSION['company_group_id'])) {
            $getCompany = "SELECT c.id, c.company_name FROM mst_company_name c
                            INNER JOIN mst_company_group_name cg ON cg.id = c.company_group_id
                            WHERE cg.id = {$_SESSION['company_group_id']} AND c.trash_status = 0
                            ORDER BY c.company_name
                        ";
            $resCompany = $db->query($getCompany);
            $data['company_list'] = $resCompany->getResult();
        }

        if (isset($_SESSION['company_group_id']) && isset($_SESSION['company_id'])) {
            // echo
            // $getParentChildUnit = "SELECT un1.id AS parent_unit_id, un.id AS child_unit_id, un1.unit_name AS parent_unit_name, un.unit_name AS child_unit_name
            //                         FROM mst_unit un
            //                         LEFT JOIN mst_unit un1 ON un1.id = un.parent_unit_id
            //                         INNER JOIN mst_company_group_name g ON g.id = un.company_group_id
            //                         INNER JOIN mst_company_name c ON c.id = un.company_id
            //                         WHERE
            //                         un.parent_unit_id != 0
            //                         AND un.trash_status = 0
            //                         AND un.org_admin_id = $org_admin_id
            //                         AND un1.trash_status = 0
            //                         AND un1.org_admin_id = $org_admin_id
            //                         AND g.trash_status = 0
            //                         AND g.org_admin_id = $org_admin_id
            //                         AND c.trash_status = 0
            //                         AND c.org_admin_id = $org_admin_id
            //                         AND un.company_group_id = {$_SESSION['company_group_id']}
            //                         AND un.company_id = {$_SESSION['company_id']}
            //                         ORDER BY parent_unit_name, child_unit_name
            //                 ";
            // die;

            $getParentChildUnit = "SELECT un.parent_unit_id, un.id AS child_unit_id, un.unit_name AS child_unit_name
                                    FROM mst_unit un
                                    LEFT JOIN mst_unit un1 ON un1.id = un.parent_unit_id
                                    INNER JOIN mst_company_group_name g ON g.id = un.company_group_id
                                    INNER JOIN mst_company_name c ON c.id = un.company_id
                                    WHERE
                                    un.trash_status = 0
                                    AND un.org_admin_id = $org_admin_id
                                    
                                    AND g.trash_status = 0
                                    AND g.org_admin_id = $org_admin_id
                                    AND c.trash_status = 0
                                    AND c.org_admin_id = $org_admin_id
                                    AND un.company_group_id = {$_SESSION['company_group_id']}
                                    AND un.company_id = {$_SESSION['company_id']}
                                    ORDER BY child_unit_id, child_unit_name
                                ";

            $resParentChildUnit = $db->query($getParentChildUnit);
            $parent_child_unit = $resParentChildUnit->getResult();
            //$data['parent_child_unit'] = $parent_child_unit;
            // $parent_child_unit_arr = [];
            // foreach ($parent_child_unit as $v) {
            //     $parent_child_unit_arr[$v->parent_unit_name][$v->child_unit_id] = $v->child_unit_name;
            // }
            // $data['parent_child_unit_list'] = $parent_child_unit_arr;
            $data['parent_child_unit'] = $parent_child_unit;
        }
        $getRole = "SELECT id, role_name FROM mst_roles ORDER BY role_name";
        $resRole = $db->query($getRole);
        $data['role_list']  = $resRole->getResult();
        return view('org_admin/add_team_member', $data);
    }

    public function check_email_existence_user_tbl()
    {
        $g = $this->request->getGet();

        $team_member_id_where = '';
        if (!empty($g['team_member_id'])) {
            $team_member_id_where = " AND id <> {$g['team_member_id']}";
        }

        $db = db_connect();

        // echo
        $checkEmail = "SELECT id
                            FROM sq_user
                            WHERE email = '{$g['email']}' 
                            AND trash_status <> 1 $team_member_id_where
                        ";
        // die;

        $resCheckEmail = $db->query($checkEmail);

        $rowEmail = $resCheckEmail->getRow();

        if (!empty($rowEmail)) {
            echo json_encode(['status' => 'success', 'msg' => 'Email already exist!']);
        } else {
            echo json_encode(['status' => 'error']);
        }
    }

    public function check_mobile_no_existence_user_tbl()
    {
        $g = $this->request->getGet();

        $team_member_id_where = '';
        if (!empty($g['team_member_id'])) {
            $team_member_id_where = " AND id <> {$g['team_member_id']}";
        }

        $db = db_connect();

        // echo
        $checkMobileNo = "SELECT id
                            FROM sq_user
                            WHERE mobile = '{$g['mobile_no']}' 
                            AND trash_status <> 1 $team_member_id_where
                        ";
        // die;

        $resCheckMobileNo = $db->query($checkMobileNo);

        $rowMobileNo = $resCheckMobileNo->getRow();

        if (!empty($rowMobileNo)) {
            echo json_encode(['status' => 'success', 'msg' => 'Mobile no. already exist!']);
        } else {
            echo json_encode(['status' => 'error']);
        }
    }

    public function check_email_existence_group_tbl()
    {
        $g = $this->request->getGet();

        $group_id_where = '';
        if (!empty($g['group_id'])) {
            $group_id_where = " AND id <> {$g['group_id']}";
        }

        $db = db_connect();

        // echo
        $checkEmail = "SELECT id
                            FROM mst_company_group_name
                            WHERE email = '{$g['email']}' 
                            AND trash_status <> 1 $group_id_where
                        ";
        // die;

        $resCheckEmail = $db->query($checkEmail);

        $rowEmail = $resCheckEmail->getRow();

        if (!empty($rowEmail)) {
            echo json_encode(['status' => 'success', 'msg' => 'Email already exist!']);
        } else {
            echo json_encode(['status' => 'error']);
        }
    }

    public function check_mobile_no_existence_group_tbl()
    {
        $g = $this->request->getGet();

        $group_id_where = '';
        if (!empty($g['group_id'])) {
            $group_id_where = " AND id <> {$g['group_id']}";
        }

        $db = db_connect();

        // echo
        $checkMobileNo = "SELECT id
                            FROM mst_company_group_name
                            WHERE contact_number = '{$g['mobile_number']}' 
                            AND trash_status <> 1 $group_id_where
                        ";
        // die;

        $resCheckMobileNo = $db->query($checkMobileNo);

        $rowMobileNo = $resCheckMobileNo->getRow();

        if (!empty($rowMobileNo)) {
            echo json_encode(['status' => 'success', 'msg' => 'Mobile no. already exist!']);
        } else {
            echo json_encode(['status' => 'error']);
        }
    }

    public function check_email_existence_company_tbl()
    {
        $g = $this->request->getGet();

        $company_id_where = '';
        if (!empty($g['company_id']) && (isset($g['form_type']) && $g['form_type'] == 'primary-form')) {
            $company_id_where = " AND id <> {$g['company_id']}";
        }

        $db = db_connect();

        // echo
        $checkEmail = "SELECT id
                        FROM mst_company_name
                        WHERE email = '{$g['email']}' 
                        AND trash_status <> 1 $company_id_where
                        ";
        // die;

        $resCheckEmail = $db->query($checkEmail);

        $rowEmail = $resCheckEmail->getRow();

        if (!empty($rowEmail)) {
            echo json_encode(['status' => 'success', 'msg' => 'Email already exist!']);
        } else {
            echo json_encode(['status' => 'error']);
        }
    }

    public function check_mobile_no_existence_company_tbl()
    {
        $g = $this->request->getGet();

        $company_id_where = '';
        if (!empty($g['company_id']) && (isset($g['form_type']) && $g['form_type'] == 'primary-form')) {
            $company_id_where = " AND id <> {$g['company_id']}";
        }

        $db = db_connect();

        // echo
        $checkMobileNo = "SELECT id
                        FROM mst_company_name
                        WHERE contact_number = '{$g['mobile_number']}' 
                        AND trash_status <> 1 $company_id_where
                        ";
        // die;

        $resCheckMobileNo = $db->query($checkMobileNo);

        $rowMobileNo = $resCheckMobileNo->getRow();

        if (!empty($rowMobileNo)) {
            echo json_encode(['status' => 'success', 'msg' => 'Mobile no. already exist!']);
        } else {
            echo json_encode(['status' => 'error']);
        }
    }

    public function create_team_member()
    {
        check_login();
        if ($this->request->getMethod() == 'post') {

            $p = $this->request->getPost();

            $org_admin_id = isset($_SESSION['org_admin_id']) && !empty($_SESSION['org_admin_id']) ? $_SESSION['org_admin_id'] : $_SESSION['uid'];

            $db = db_connect();
            
            $checkEmailUser = "SELECT id FROM sq_user WHERE email = '{$p['email']}' AND trash_status <> 1 ";
            $resCheckEmailUser = $db->query($checkEmailUser);
            $rowEmailUser = $resCheckEmailUser->getRow();
            //echo $checkEmailUser;exit;
            
            $checkExistUser = "SELECT id FROM sq_user WHERE email = '{$p['email']}' AND trash_status <> 1 AND company_group_id={$p['company_group_id']} AND company_id={$p['company_id']} AND unit_id={$p['unit_id']} AND role_id={$p['role_id']}";
            $resCheckExistUser = $db->query($checkExistUser);
            $rowExistUser = $resCheckExistUser->getRow();
            if (!empty($rowExistUser)) {
                session()->setFlashdata('message', 'User already exist');
                session()->setFlashdata('alert-class', 'alert-danger');

                $base_url = base_url('api/public/index.php/organization_admin/list_team_member');
                return redirect()->to($base_url);
            }
            $uexist_data = $this->check_user_exist_another_org($p['email']);
            if(!empty($uexist_data)){
                session()->setFlashdata('message', 'User already exist in another organisation');
                session()->setFlashdata('alert-class', 'alert-danger');
                $base_url = base_url('api/public/index.php/organization_admin/list_team_member');
                return redirect()->to($base_url);
            }
            
            
            // echo
            $getCompany = "SELECT c.id,c.addedby, c.company_name,cg.addedby as group_admin_id, cg.group_name FROM mst_company_name c INNER JOIN mst_company_group_name cg ON cg.id = c.company_group_id
            WHERE cg.id = {$p['company_group_id']}
            ORDER BY c.company_name
            ";
            // die;

            $resCompany = $db->query($getCompany);
            $rowCompany = $resCompany->getRow();

            $getUnit = "SELECT id, unit_name
                        FROM mst_unit
                        WHERE trash_status = 0
                        AND id = {$p['unit_id']}
                        ";

            $resUnit = $db->query($getUnit);
            $rowUnit = $resUnit->getRow();

            $getRole = "SELECT id, role_name
                        FROM mst_roles
                        WHERE id = {$p['role_id']}
                        ";

            $resRole = $db->query($getRole);
            $rowRole = $resRole->getRow();
            
            if (empty($rowEmailUser)) {
                $companyFirstTwo = ucfirst(substr($rowCompany->company_name, 0, 2));
                $groupFirstTwo = ucfirst(substr($rowCompany->group_name, 0, 2));
                $mobileNoLastFour = substr($p['mobile_no'], -4);
                $password = $companyFirstTwo . $groupFirstTwo . $mobileNoLastFour;
                
                $authority_data = $this->get_parent_user_authority($_SESSION['uid']);
                if(!empty($authority_data)){
                    $no_of_seek_feedback_allowed = $authority_data->no_of_seek_feedback_allowed;
                    $sq_detailed_assessment = $authority_data->sq_detailed_assessment;
                    $sup_org_admin_id = $authority_data->sup_org_admin_id;
                }else{
                    $no_of_seek_feedback_allowed = 0;
                    $sq_detailed_assessment = 0;
                    $sup_org_admin_id = 0;
                }
                
                $cmp_adm_data = $this->get_company_admin_id($p['company_id']);
                if(!empty($cmp_adm_data)){
                    $company_admin_id = $cmp_adm_data->user_id;
                }else{
                    $company_admin_id = $rowCompany->addedby;
                }
                
                $grp_adm_data = $this->get_grp_admin_id($p['company_group_id']);
                if(!empty($grp_adm_data)){
                    $group_admin_id = $grp_adm_data->user_id;
                }else{
                    $group_admin_id = $rowCompany->group_admin_id;
                }
                
                $sq_user_tbl = $db->table('sq_user');
                
                $email_str = strtolower($p['email']).$p['email_domain'];
                $sq_user_data = [
                    'username' => strtolower($p['name']),
                    'password' => md5($password),
                    'email' => $email_str,//strtolower($p['email']),
                    'full_name' => ucwords(strtolower($p['name'])),
                    'account_type_id' => 2,
                    'group_ids' => $p['role_id'] == 3 ? 1 : 2,
                    'user_token' => 'logout-' . time(),
                    'trash_status' => '',
                    'created_time' => date('Y-m-d H:i:s'),
                    'token' => '',
                    'hash_token' => '',
                    'master_journeys_allowed' => '',
                    'child_journeys_allowed' => '',
                    'no_of_seek_feedback_allowed' => $no_of_seek_feedback_allowed,
                    'sq_detailed_assessment' => $sq_detailed_assessment,
                    'mobile' => $p['mobile_no'],
                    'gender' => '',
                    'organisation_name' => '',
                    'company_group_id' => $p['company_group_id'],
                    'company_id' => $p['company_id'],
                    'unit_id' => $p['unit_id'],
                    'designation' => $p['designation'],
                    'role_id' => $p['role_id'],
                    'is_team_member' => 1,
                    'parent_team_member' => $org_admin_id,
                    'is_active' => 1,
                    'company_admin_id'=>$company_admin_id,
                    'group_admin_id'=>$group_admin_id,
                    'addedby' => $_SESSION['uid'],
                    'sup_org_admin_id'=>(isset($_SESSION['is_sup_org_admin'])==1 ? $_SESSION['uid'] : $sup_org_admin_id),
                    'is_sup_org_admin'=>0
                ];
                if($p['role_id']==1 || $p['role_id']==2){
                    $sq_user_data['is_allow_org_structure']=0;
                    $sq_user_data['is_allow_org_assesment']=0;
                    $sq_user_data['is_allow_team_assesment']=1;
                }else{
                    $sq_user_data['is_allow_org_structure']=0;
                    $sq_user_data['is_allow_org_assesment']=0;
                    $sq_user_data['is_allow_team_assesment']=0;
                }
                if ($sq_user_tbl->insert($sq_user_data)) {
                    $last_insert_user_id = $db->insertID();
                    
                    $user_group_company_unit_tbl = $db->table('user_group_company_unit');
                    $user_group_company_unit_data = [
                        'user_id' => $last_insert_user_id,
                        'group_id' => $p['company_group_id'],
                        'company_id' => $p['company_id'],
                        'unit_id' => $p['unit_id'],
                        'is_group_admin'=>0,
                        'is_company_admin'=>0,
                        'is_team_member'=>1,
                        'role_id'=>$p['role_id']
                    ];  
                    $user_group_company_unit_tbl->insert($user_group_company_unit_data);
                    
                    
                    $common_model = new Common_model();
                    $subject = 'Welcome To MIJS';
                    $added_by_name = $_SESSION['full_name'];
                    $loginUrl = base_url('api/public/index.php/frontend/login');
    
                    $common_model->send_welcome_mail_on_org_master_add($p['name'], $email_str, $subject, $loginUrl, $password, $added_by_name, ucfirst($rowCompany->group_name), ucfirst($rowCompany->company_name), ucfirst($rowUnit->unit_name), $rowRole->role_name);
    
                    if (isset($p['submit_add_more'])) {
    
                        $sessionData = [
                            'company_group_id' => $p['company_group_id'],
                            'company_id' => $p['company_id'],
                            'unit_id' => $p['unit_id'],
                            'role_id' => $p['role_id']
                        ];
                        session()->setFlashdata($sessionData);
    
                        session()->setFlashdata('message', 'Team Member added successfully');
                        session()->setFlashdata('alert-class', 'alert-success');
    
                        $base_url = base_url('api/public/index.php/organization_admin/add_team_member');
                        return redirect()->to($base_url);
                    }
    
                    session()->setFlashdata('message', 'Team Member added successfully');
                    session()->setFlashdata('alert-class', 'alert-success');
    
                    $base_url = base_url('api/public/index.php/organization_admin/list_team_member');
                    return redirect()->to($base_url);
                } else {
    
                    session()->setFlashdata('message', 'Data not saved');
                    session()->setFlashdata('alert-class', 'alert-danger');
    
                    $base_url = base_url('api/public/index.php/organization_admin/list_team_member');
                    return redirect()->to($base_url);
                }
            }else {
                $user_group_company_unit_tbl = $db->table('user_group_company_unit');
                $user_group_company_unit_data = [
                    'user_id' => $rowEmailUser->id,
                    'group_id' => $p['company_group_id'],
                    'company_id' => $p['company_id'],
                    'unit_id' => $p['unit_id'],
                    'is_group_admin'=>0,
                    'is_company_admin'=>0,
                    'is_team_member'=>1,
                    'role_id'=>$p['role_id']
                ];

                if ($user_group_company_unit_tbl->insert($user_group_company_unit_data)) {
                    session()->setFlashdata('message', 'Team Member added successfully');
                    session()->setFlashdata('alert-class', 'alert-success');

                    $base_url = base_url('api/public/index.php/organization_admin/list_team_member');
                    return redirect()->to($base_url);
                } else {
                    session()->setFlashdata('message', 'Data not saved');
                    session()->setFlashdata('alert-class', 'alert-danger');

                    $base_url = base_url('api/public/index.php/organization_admin/list_team_member');
                    return redirect()->to($base_url);
                }
            }
        }
    }

    public function get_company()
    {
        $g = $this->request->getGet();

        $company_group_id = $g['company_group_id'];
        $company_group_name = $g['company_group_name'];

        $db = db_connect();

        // echo
        $getCompany = "SELECT 
        c.id, c.company_name
        FROM mst_company_name c
        INNER JOIN mst_company_group_name cg ON cg.id = c.company_group_id
        WHERE cg.id = $company_group_id AND c.trash_status = 0
        ORDER BY c.company_name
        ";
        // die;

        $resCompany = $db->query($getCompany);
        $data = $resCompany->getResult();

        if ($data) {

            echo json_encode(['status' => 'success', 'res' => $data]);
        } else {

            echo json_encode(['status' => 'error', 'msg' => 'Company not found for ' . $company_group_name]);
        }
    }

    public function get_unit()
    {
        $g = $this->request->getGet();
        $company_group_id = $g['company_group_id'];
        $company_id = $g['company_id'];

        $org_admin_id = isset($_SESSION['sup_org_admin_id']) && !empty($_SESSION['sup_org_admin_id']) ? $_SESSION['sup_org_admin_id'] : $_SESSION['uid'];

        $db = db_connect();

        // AND c.org_admin_id = $org_admin_id 
        $getParentChildUnit = "SELECT un.parent_unit_id, un.id AS child_unit_id,un.unit_name AS child_unit_name
                                    FROM mst_unit un
                                    
                                    LEFT JOIN mst_unit un1 ON un1.id = un.parent_unit_id
                                    INNER JOIN mst_company_group_name g ON g.id = un.company_group_id
                                    INNER JOIN mst_company_name c ON c.id = un.company_id
                                    WHERE
                                    
                                    un.trash_status = 0
                                    AND un.org_admin_id = $org_admin_id
                                    
                                    AND g.trash_status = 0
                                    AND g.org_admin_id = $org_admin_id
                                    AND c.trash_status = 0
                                    
                                    AND un.company_group_id = $company_group_id
                                    AND un.company_id = $company_id
                                    ORDER BY IFNULL(un1.unit_name,un.unit_name),
                                    COALESCE(un.parent_unit_id, un.id),
                                    un.parent_unit_id != 0,
                                    un.unit_name
                            ";
        //die;

        // $getParentChildUnit = "SELECT un1.id AS parent_unit_id, un.id AS child_unit_id, un1.unit_name AS parent_unit_name, un.unit_name AS child_unit_name
        //                             FROM mst_unit un
        //                             LEFT JOIN mst_unit un1 ON un1.id = un.parent_unit_id
        //                             INNER JOIN mst_company_group_name g ON g.id = un.company_group_id
        //                             INNER JOIN mst_company_name c ON c.id = un.company_id
        //                             WHERE
        //                             un.parent_unit_id != 0
        //                             AND un.trash_status = 0
        //                             AND un.org_admin_id = $org_admin_id
        //                             AND un1.trash_status = 0
        //                             AND un1.org_admin_id = $org_admin_id
        //                             AND g.trash_status = 0
        //                             AND g.org_admin_id = $org_admin_id
        //                             AND c.trash_status = 0
        //                             AND c.org_admin_id = $org_admin_id
        //                             AND un.company_group_id = $company_group_id
        //                             AND un.company_id = $company_id
        //                             ORDER BY parent_unit_name, child_unit_name
        //                     ";                    
        // die;

        $resParentChildUnit = $db->query($getParentChildUnit);
        $parent_child_unit = $resParentChildUnit->getResult();

        // $parent_child_unit_arr = [];
        // foreach ($parent_child_unit as $v) {
        //     $parent_child_unit_arr[$v->parent_unit_name][$v->child_unit_id] = $v->child_unit_name;
        // }
        
        
        $email_domain_arr = array();
        $GroupAdminEmailDomainData = $db->query("SELECT u.email FROM `user_group_company_unit` ugcu
                                                LEFT JOIN sq_user u ON u.id=ugcu.user_id
                                                WHERE ugcu.group_id = ".$company_group_id." AND ugcu.is_group_admin = 1");
        $GroupAdminEmailDomain = $GroupAdminEmailDomainData->getRow();
        if(isset($GroupAdminEmailDomain->email)){
            $groupdomain = explode("@",$GroupAdminEmailDomain->email);
            $email_domain_arr[] = "@".$groupdomain[1];
        }
        $CompanyAdminEmailDomainData = $db->query("SELECT u.email FROM `user_group_company_unit` ugcu
                                                LEFT JOIN sq_user u ON u.id=ugcu.user_id
                                                WHERE ugcu.company_id = ".$company_id." AND ugcu.is_company_admin = 1");
        $CompanyAdminEmailDomain = $CompanyAdminEmailDomainData->getRow();
        if(isset($CompanyAdminEmailDomain->email)){
            $companydomain = explode("@",$CompanyAdminEmailDomain->email);
            $email_domain_arr[] = "@".$companydomain[1];
        }
        $email_domain_arr = array_unique($email_domain_arr);
        $email_domain_opt = '<option value="">Select Domain</option>';
        if(count($email_domain_arr) > 0){
            foreach($email_domain_arr as $dm){
                $email_domain_opt .= '<option value="'.$dm.'">'.$dm.'</option>';
            }
        }

        if (!empty($parent_child_unit)) {
            echo json_encode(['status' => 'success', 'parent_child_unit_arr' => $parent_child_unit , 'emaildomain_option' => $email_domain_opt]);
        } else {
            echo json_encode(['status' => 'team_member_list_page']);
        }
    }

    public function get_parent_unit()
    {
        $g = $this->request->getGet();
        $company_group_id = $g['company_group_id'];
        $company_id = $g['company_id'];

        $org_admin_id = isset($_SESSION['sup_org_admin_id']) && !empty($_SESSION['sup_org_admin_id']) ? $_SESSION['sup_org_admin_id'] : $_SESSION['uid'];

        $db = db_connect();

        // echo
        $getParentUnit = "SELECT un.id, un.unit_name
                                    FROM mst_unit un
                                    INNER JOIN mst_company_group_name g ON g.id = un.company_group_id
                                    INNER JOIN mst_company_name c ON c.id = un.company_id
                                    WHERE
                                    un.parent_unit_id = 0
                                    AND un.trash_status = 0
                                    AND un.org_admin_id = $org_admin_id
                                    AND g.trash_status = 0
                                    AND g.org_admin_id = $org_admin_id
                                    AND c.trash_status = 0
                                    AND c.org_admin_id = $org_admin_id
                                    AND un.company_group_id = $company_group_id
                                    AND un.company_id = $company_id
                                    ORDER BY un.unit_name
                            ";
        // die;

        $resParentUnit = $db->query($getParentUnit);
        $parent_unit = $resParentUnit->getResult();

        if ($parent_unit) {
            echo json_encode(['status' => 'success', 'res' => $parent_unit]);
        } else {
            echo json_encode(['status' => 'team_member_list_page']);
        }
    }
    public function no_access(){
		$db = \Config\Database::connect(); 
		$db1 = \Config\Database::connect('writeDB');
		$db2 = \Config\Database::connect('readDB');
		$data['title'] = 'Home';
		
    	$data['is_dashboard'] = 1;
		return view('frontend/no_access_msg',$data); 
	}
    public function list_team_member()
    {
        check_login();
        $allowed_total_user = get_organisation_total_users_count($_SESSION['uid']);
        $org_admin_access_data = $_SESSION['org_admin_access_data'];
        if(isset($org_admin_access_data) && $org_admin_access_data->is_allow_org_structure==1 && $org_admin_access_data->org_duration_date >= date('Y-m-d') && $org_admin_access_data->org_allow_no_of_user > $allowed_total_user){
            $data['add_url'] = 'api/public/index.php/organization_admin/add_team_member';
        }
        // if(isset($_SESSION['is_allow_org_structure']) &&  $_SESSION['is_allow_org_structure']==0){
        //     $base_url = base_url('api/public/index.php/organization_admin/no_access');
        //     return redirect()->to($base_url);
        // }
        $data['title'] = 'Organisation Structure';
        $data['manage_title'] = '';
        $data['main_page'] = 'api/public/index.php/frontend/front_dashboard';
        $data['current_page'] = 'api/public/index.php/organization_admin/list_team_member';
        //$data['add_url'] = 'api/public/index.php/organization_admin/add_team_member';
        $data['get_list_data_url'] = 'get_list_team_member';
        $data['delete_url'] = 'delete_team_member';
        $data['get_unit_url'] = 'api/public/index.php/organization_admin/get_unit';
        $data['get_parent_unit_url'] = 'api/public/index.php/organization_admin/get_parent_unit';

        $org_admin_id = isset($_SESSION['sup_org_admin_id']) && !empty($_SESSION['sup_org_admin_id']) ? $_SESSION['sup_org_admin_id'] : $_SESSION['uid'];

        $db = db_connect();

        // echo
        $checkIfCompanyAdmin = "SELECT
                                    id
                                    FROM sq_user
                                    WHERE is_company_admin = 1
                                    AND is_active = 1
                                    AND trash_status = 0
                                    AND id = {$org_admin_id}
        ";
        // die;

        $resifCompanyAdmin = $db->query($checkIfCompanyAdmin);
        $ifCompanyAdmin = $resifCompanyAdmin->getResultArray();

        $where_user_id = '';
        if (!empty($ifCompanyAdmin)) {
            $where_user_id = " AND u.id = {$_SESSION['uid']}";
        }
        
        $gcwhere = ' WHERE 1=1 ';
        if(isset($_SESSION['sup_org_admin_id']) && $_SESSION['sup_org_admin_id']==0){
            $gcwhere .=' AND (u.sup_org_admin_id='.$_SESSION['uid'].')';
        }
        if(isset($_SESSION['is_group_admin']) && $_SESSION['is_group_admin']==1){
            $gcwhere .=' AND (u.addedby='.$_SESSION['uid'].' OR u.group_admin_id='.$_SESSION['uid'].' OR u.id='.$_SESSION['uid'].')';
        }
        if(isset($_SESSION['is_company_admin']) && $_SESSION['is_company_admin']==1){
            $gcwhere .=' AND (u.addedby='.$_SESSION['uid'].' OR u.company_admin_id='.$_SESSION['uid'].' OR u.id='.$_SESSION['uid'].')';
        }
        
        
        
        
        $getFirstRowGroupCompany = "SELECT ugcu.company_id AS company_id, ugcu.id, g.group_name,ugcu.group_id, c.company_name FROM sq_user u 
                                LEFT JOIN user_group_company_unit ugcu ON ugcu.user_id = u.id 
                                LEFT JOIN mst_company_group_name g ON g.id = ugcu.group_id
                                LEFT JOIN mst_company_name c ON c.id = ugcu.company_id 
                                $gcwhere
                                group by ugcu.group_id,ugcu.company_id LIMIT 1";
        
        
        

        $resResult = $db->query($getFirstRowGroupCompany);
        $data['first_row_group_company'] = $resResult->getRow();

        
        
        // echo 
        $getGroupAndCompanies = "SELECT ugcu.company_id AS company_id, ugcu.id, g.group_name,ugcu.group_id, c.company_name FROM sq_user u 
                                LEFT JOIN user_group_company_unit ugcu ON ugcu.user_id = u.id 
                                LEFT JOIN mst_company_group_name g ON g.id = ugcu.group_id
                                LEFT JOIN mst_company_name c ON c.id = ugcu.company_id 
                                $gcwhere
                                AND c.trash_status=0
                                group by ugcu.group_id,ugcu.company_id";
        // die;
        $resGroupAndCompanies = $db->query($getGroupAndCompanies);
        $group_and_companies = $resGroupAndCompanies->getResult();

        $group_id_arr = [];
        $group_and_companies_arr = [];
        foreach ($group_and_companies as $v) {
            $group_id_arr[$v->group_name] = $v->group_id;
            $group_and_companies_arr[$v->group_name][$v->company_id] = $v->company_name;
        }

        $data['group_id_list'] = $group_id_arr;
        $data['group_and_companies_list'] = $group_and_companies_arr;

        if (!empty($data['first_row_group_company'])) {
            
            $where2 ='';
            if($data['first_row_group_company']->group_id !='' && $data['first_row_group_company']->group_id != NULL){
                $where2 .= " AND un.company_group_id = {$data['first_row_group_company']->group_id}";
            }
            if($data['first_row_group_company']->company_id !='' && $data['first_row_group_company']->company_id != NULL){
                $where2 .= " AND un.company_id = {$data['first_row_group_company']->company_id}";
            }
            
            
            // echo
            $getParentChildUnit = "SELECT un.parent_unit_id, un.id AS child_unit_id,un.unit_name AS child_unit_name
                                    FROM mst_unit un
                                    
                                    LEFT JOIN mst_unit un1 ON un1.id = un.parent_unit_id
                                    INNER JOIN mst_company_group_name g ON g.id = un.company_group_id
                                    INNER JOIN mst_company_name c ON c.id = un.company_id
                                    WHERE
                                    
                                    un.trash_status = 0
                                    AND un.org_admin_id = $org_admin_id
                                    AND c.trash_status = 0
                                    AND g.trash_status = 0
                                    AND g.org_admin_id = $org_admin_id
                                    AND c.trash_status = 0
                                    AND c.org_admin_id = $org_admin_id
                                    -- $where2
                                    -- AND un.company_group_id = {$data['first_row_group_company']->group_id}
                                    -- AND un.company_id = {$data['first_row_group_company']->company_id}
                                    ORDER BY IFNULL(un1.unit_name,un.unit_name),
                                    COALESCE(un.parent_unit_id, un.id),
                                    un.parent_unit_id != 0,
                                    un.unit_name
                            ";
            // die;


            $resParentChildUnit = $db->query($getParentChildUnit);
            $parent_child_unit = $resParentChildUnit->getResult();
            $data['parent_child_unit'] = $parent_child_unit;
        }

        return view('org_admin/list_team_member', $data);
    }

    public function get_list_team_member()
    {
        $db = db_connect();
        $dtSearchColumns = array('unit_name', 'full_name', 'role_name');
        $DTRenderArray = $this->DT_Render_Columns($dtSearchColumns);
        $dtWhere = $DTRenderArray['dtWhere'];
        $dtOrder = $DTRenderArray['dtOrder'];
        $dtLimit = $DTRenderArray['dtLimit'];

        $DTRenderArray = $this->Load_Datatable_For_Team_Member($dtWhere, $dtOrder, $dtLimit); 

        $output = array(
            "sEcho" => $_GET['sEcho'] ? $_GET['sEcho'] : 0,
            "iTotalRecords" => $DTRenderArray['dtPerPageRecords'],
            "iTotalDisplayRecords" => $DTRenderArray['dtTotalRecords'],
            "aaData" => array()
        );
        $parunitprev='';
        $chldunitprev='';
        
        $rno = 0;
        foreach ($DTRenderArray['ResultSet'] as $dtRow) {
            $rno++;
            if($parunitprev == $dtRow->parent_unit){
                $parent_unit ='';
            }else{
                $parent_unit = $dtRow->parent_unit;
            }
            if($chldunitprev == $dtRow->child_unit){
                $child_unit ='';
            }else{
                $child_unit = $dtRow->child_unit;
            }
            if($dtRow->is_group_admin){
                $edit_lnk = base_url('api/public/index.php/organization_admin/edit_group/' . $dtRow->group_id.'/1');
            }elseif($dtRow->is_company_admin){
                $edit_lnk = base_url('api/public/index.php/organization_admin/edit_company/' . $dtRow->company_id.'/1');
            }else{
                $edit_lnk = base_url('api/public/index.php/organization_admin/edit_team_member/' . $dtRow->ugc_id);
            }
            $row = [];
            $editBtn = '<a class="mr-2 close-icon tooltip-btn " href="' . $edit_lnk . '"><img src="' . base_url("new_frontend_assets/images/edit-icon.png") . '" alt=""> <span class="tooltiptext02">Edit</span></a>';
            $deleteBtn = '<a data-id="' . $dtRow->ugc_id . '" class="delete-btn close-icon tooltip-btn " href="#"><img src="' . base_url("new_frontend_assets/images/delete-icon.png") . '" alt=""> <span class="tooltiptext02">Delete</span></a>';

            $actionBtn = "<div class='btn-group'>$editBtn $deleteBtn</div>";
            
            $filterid = $this->request->getGet();
            
            if($rno==1 && isset($_SESSION['sup_org_admin_id']) && $_SESSION['sup_org_admin_id']!=0 && $filterid['unit_id']==''){
                $getsuper = "SELECT full_name FROM sq_user WHERE id =". $_SESSION['sup_org_admin_id'];
                $ressuper = $db->query($getsuper);
                $rowSuper = $ressuper->getRow();
                
                $row[] = '';
                $row[] = '';
                $row[] = 'Account Owner';
                $row[] = $rowSuper->full_name;
                $row[] = 'Active';
                $row[] = '';
            }else{
                $row[] = $parent_unit;//$dtRow->parent_unit;
                $row[] = $child_unit;//$dtRow->child_unit;
                $row[] = $dtRow->role_name;
                $row[] = $dtRow->full_name;
                $row[] = $dtRow->is_active == 1 ? 'Active' : 'In Active';
                $row[] = $actionBtn;
            }
            $output['aaData'][] = $row;
            
            $parunitprev = $dtRow->parent_unit;
            $chldunitprev = $dtRow->child_unit;
        }

        echo json_encode($output);
    }

    public function Load_Datatable_For_Team_Member($dtWhere, $dtOrder, $dtLimit)
    {

        $org_admin_id = isset($_SESSION['org_admin_id']) && !empty($_SESSION['org_admin_id']) ? $_SESSION['org_admin_id'] : $_SESSION['uid'];

        $db = db_connect();
        
        $gcwhere = ' WHERE 1=1 ';
        
        if(isset($_SESSION['sup_org_admin_id']) && $_SESSION['sup_org_admin_id']==0){
            $gcwhere .=' AND u.id IN (SELECT id FROM sq_user WHERE sup_org_admin_id='.$_SESSION['uid'].')';
        }elseif(isset($_SESSION['is_group_admin']) && $_SESSION['is_group_admin']==1){
            $gcwhere .=' AND (u.addedby='.$_SESSION['uid'].' OR u.group_admin_id='.$_SESSION['uid'].' OR u.id='.$_SESSION['uid'].' OR u.company_admin_id='.$_SESSION['uid'].')';
        }elseif(isset($_SESSION['is_company_admin']) && $_SESSION['is_company_admin']==1){
            $gcwhere .=' AND (u.addedby='.$_SESSION['uid'].' OR u.company_admin_id='.$_SESSION['uid'].' OR u.id='.$_SESSION['uid'].')';
        }
        // echo
        $getResult = "SELECT u.sup_org_admin_id,
                            un.id AS un_id,
                            un1.id AS un1_id,
                            un.parent_unit_id AS parent_unit_id,
                            u.id,
                            ugc.id as ugc_id,
                            ugc.user_id, 
                            u.email,
                            u.is_team_member,
                            u.is_active,
                            ugc.is_group_admin,    
                            ugc.is_company_admin,
                            ugc.company_id,
                            g.id AS group_id,
                            g.group_name,
                            c.company_name,
                            u.unit_id,
                            CASE WHEN un.parent_unit_id != 0 THEN(
                            SELECT
                                unit_name
                            FROM
                                mst_unit
                            WHERE
                                id = un.parent_unit_id
                        ) ELSE un1.unit_name
                        END AS parent_unit,
                        CASE WHEN un.unit_name IS NULL THEN '---' ELSE un.unit_name
                        END AS child_unit,
                        u.full_name,
                        r.id AS role_id,
                        CASE WHEN ugc.is_group_admin = 1 THEN 'Group Admin' 
                        WHEN ugc.is_company_admin = 1 THEN 'Company Admin' 
                        WHEN ugc.is_team_member = 1 THEN r.role_name
                        ELSE r.role_name
                        END AS role_name,
                        CASE 
                            	WHEN ugc.is_group_admin = 1 THEN 1 
                                WHEN ugc.is_company_admin = 1 THEN 2 
                                WHEN r.id = 1 THEN 3 
                                WHEN r.id = 2 THEN 4  
                            	WHEN ugc.is_team_member = 1 THEN 5 
                        END AS role_name_listing
                        FROM
                            sq_user u
                        LEFT JOIN user_group_company_unit ugc ON
                            ugc.user_id = u.id    
                        LEFT JOIN mst_company_group_name g ON
                            g.id = u.company_group_id AND g.trash_status = 0 AND g.org_admin_id = $org_admin_id
                        LEFT JOIN mst_company_name c ON
                            c.id = u.company_id AND c.trash_status = 0 AND c.org_admin_id = $org_admin_id
                        LEFT JOIN mst_unit un ON
                            un.id = ugc.unit_id AND un.parent_unit_id != 0
                        LEFT JOIN mst_unit un1 ON
                            un1.id = ugc.unit_id AND un1.parent_unit_id = 0
                        LEFT JOIN mst_roles r ON
                            r.id = ugc.role_id    
                        
                        $gcwhere
                        AND
                        u.is_active = 1
                        AND ugc.trash_status = 0
                        AND u.trash_status = 0 
                        
                        -- AND u.parent_team_member = $org_admin_id
                        $dtWhere
                        ORDER BY
                            un.unit_name,
                        	role_name_listing,
                            -- g.group_name,
                            -- c.company_name,
                            -- r.id,
                            u.full_name";
            //  die;
        $resResult = $db->query($getResult);
        $result = $resResult->getResult();
        
        $getAllCount = "SELECT count(u.id) AS total
                        FROM
                            sq_user u
                        LEFT JOIN user_group_company_unit ugc ON
                            ugc.user_id = u.id    
                        LEFT JOIN mst_company_group_name g ON
                            g.id = u.company_group_id AND g.trash_status = 0 AND g.org_admin_id = $org_admin_id
                        LEFT JOIN mst_company_name c ON
                            c.id = u.company_id AND c.trash_status = 0 AND c.org_admin_id = $org_admin_id
                        LEFT JOIN mst_unit un ON
                            un.id = ugc.unit_id AND un.parent_unit_id != 0
                        LEFT JOIN mst_unit un1 ON
                            un1.id = ugc.unit_id AND un1.parent_unit_id = 0
                        LEFT JOIN mst_roles r ON
                            r.id = ugc.role_id    
                        
                        $gcwhere
                        AND
                        u.is_active = 1
                        AND ugc.trash_status = 0
                        AND u.trash_status = 0 
                        AND c.trash_status = 0 
                        AND g.trash_status = 0 
                        -- AND u.parent_team_member = $org_admin_id
                        $dtWhere
        ";
        // die;

        $getCount = $db->query($getAllCount);
        $resCount = $getCount->getResult();

        $data['ResultSet'] = $result;
        $data['dtPerPageRecords'] = count($data['ResultSet']);

        $data['dtTotalRecords'] = isset($resCount[0]->total) ? $resCount[0]->total : 0;
        return $data;
    }

    public function edit_team_member($id)
    {
        check_login();
        // $data['team_member_id'] = $id;
        $data['title'] = 'Edit Team';
        $data['manage_title'] = 'Org structure';
        $data['main_page'] = 'api/public/index.php/frontend/front_dashboard';
        $data['list_page'] = 'api/public/index.php/organization_admin/list_team_member';
        $data['current_page'] = 'api/public/index.php/organization_admin/edit_team_member/' . $id;
        $data['form_action'] = 'api/public/index.php/organization_admin/update_team_member/' . $id;
        $data['get_company_url'] = 'api/public/index.php/organization_admin/get_company';
        $data['get_unit_url'] = 'api/public/index.php/organization_admin/get_unit';
        $data['get_parent_unit_url'] = 'api/public/index.php/organization_admin/get_parent_unit';

        $data['add_group_ajax_url'] = 'api/public/index.php/organization_admin/create_group';
        $data['add_company_ajax_url'] = 'api/public/index.php/organization_admin/create_company';
        $data['add_unit_ajax_url'] = 'api/public/index.php/organization_admin/create_unit';

        $data['check_email_existence_url_user_tbl'] = 'api/public/index.php/organization_admin/check_email_existence_user_tbl';
        $data['check_email_existence_url_group_tbl'] = 'api/public/index.php/organization_admin/check_email_existence_group_tbl';
        $data['check_email_existence_url_company_tbl'] = 'api/public/index.php/organization_admin/check_email_existence_company_tbl';

        $data['check_mobile_no_existence_url_user_tbl'] = 'api/public/index.php/organization_admin/check_mobile_no_existence_user_tbl';
        $data['check_mobile_no_existence_url_group_tbl'] = 'api/public/index.php/organization_admin/check_mobile_no_existence_group_tbl';
        $data['check_mobile_no_existence_url_company_tbl'] = 'api/public/index.php/organization_admin/check_mobile_no_existence_company_tbl';
        
        $data['get_email_user_detail_url'] = 'api/public/index.php/organization_admin/get_email_user_detail';

        $org_admin_id = isset($_SESSION['sup_org_admin_id']) && !empty($_SESSION['sup_org_admin_id']) ? $_SESSION['sup_org_admin_id'] : $_SESSION['uid'];

        $db = db_connect();

        // echo
        $getTeamMember = "SELECT ugcu.group_id,ugcu.user_id,u.company_group_id, ugcu.company_id, ugcu.unit_id, u.full_name, u.designation, ugcu.role_id, u.email, u.mobile,ugcu.id as ugcu_id
                            FROM sq_user u
                            LEFT JOIN user_group_company_unit ugcu ON ugcu.user_id=u.id
                            -- AND u.company_group_id = ugcu.group_id AND u.company_id = ugcu.company_id AND u.unit_id = ugcu.unit_id
                            WHERE ugcu.id = $id
                            AND u.is_active = 1
                            AND u.role_id IS NOT NULL
                            AND u.trash_status = 0
                            AND ugcu.is_team_member = 1
                            -- AND u.parent_team_member = $org_admin_id
                        ";
        // die;

        $resTeamMember = $db->query($getTeamMember);
        $data['team_member_row'] = $resTeamMember->getRow();
        //echo "<pre>";print_r($data['team_member_row']);exit;
        $getGroup = "SELECT id, group_name
                        FROM mst_company_group_name
                        WHERE trash_status = 0 
                        AND org_admin_id = $org_admin_id
                        ORDER BY group_name
                        ";

        $resGroup = $db->query($getGroup);
        $data['group_list']  = $resGroup->getResult();

        // echo
        $getCompany = "SELECT id, company_name
                        FROM mst_company_name
                        WHERE trash_status = 0 
                        -- AND org_admin_id = $org_admin_id 
                        AND company_group_id = {$data['team_member_row']->group_id}
                        ORDER BY company_name
                        ";
        // die;

        $resCompany = $db->query($getCompany);
        $data['company_list'] = $resCompany->getResult();

        // echo
        $getParentChildUnit = "SELECT un.parent_unit_id, un.id AS child_unit_id,un.unit_name AS child_unit_name
                                    FROM mst_unit un
                                    
                                    INNER JOIN mst_company_group_name g ON g.id = un.company_group_id
                                    INNER JOIN mst_company_name c ON c.id = un.company_id
                                    WHERE
                                    
                                    un.trash_status = 0
                                    AND un.org_admin_id = $org_admin_id
                                    
                                    AND g.trash_status = 0
                                    AND g.org_admin_id = $org_admin_id
                                    AND c.trash_status = 0
                                    -- AND c.org_admin_id = $org_admin_id
                                    AND un.company_group_id = {$data['team_member_row']->company_group_id}
                                    AND un.company_id = {$data['team_member_row']->company_id}
                                    ORDER BY child_unit_id, child_unit_name
                            ";
        // die;

        // $getParentChildUnit = "SELECT un1.id AS parent_unit_id, un.id AS child_unit_id, un1.unit_name AS parent_unit_name, un.unit_name AS child_unit_name
        //                             FROM mst_unit un
        //                             LEFT JOIN mst_unit un1 ON un1.id = un.parent_unit_id
        //                             INNER JOIN mst_company_group_name g ON g.id = un.company_group_id
        //                             INNER JOIN mst_company_name c ON c.id = un.company_id
        //                             WHERE
        //                             un.parent_unit_id != 0
        //                             AND un.trash_status = 0
        //                             AND un.org_admin_id = $org_admin_id
        //                             AND un1.trash_status = 0
        //                             AND un1.org_admin_id = $org_admin_id
        //                             AND g.trash_status = 0
        //                             AND g.org_admin_id = $org_admin_id
        //                             AND c.trash_status = 0
        //                             AND c.org_admin_id = $org_admin_id
        //                             AND un.company_group_id = {$data['team_member_row']->company_group_id}
        //                             AND un.company_id = {$data['team_member_row']->company_id}
        //                             ORDER BY parent_unit_name, child_unit_name
        //                     ";


        $resParentChildUnit = $db->query($getParentChildUnit);
        $parent_child_unit = $resParentChildUnit->getResult();

        // $parent_child_unit_arr = [];
        // foreach ($parent_child_unit as $v) {
        //     $parent_child_unit_arr[$v->parent_unit_name][$v->child_unit_id] = $v->child_unit_name;
        // }

        // $data['parent_child_unit_list'] = $parent_child_unit_arr;

        $getRoleList = "SELECT id, role_name FROM mst_roles ORDER BY id ";
        $resRoleList = $db->query($getRoleList);
        $data['role_list']  = $resRoleList->getResult();
        
        $getEmailDomain = "SELECT email FROM `sq_user` WHERE (`company_group_id` = ".$data['team_member_row']->company_group_id." AND `is_group_admin` = 1 ) OR (company_id = ".$data['team_member_row']->company_id." AND is_company_admin=1) ORDER BY `id` ASC";
        $resDomain = $db->query($getEmailDomain);
        $resDomainarr = $resDomain->getResult();
        $emailDomainarr = array();
        foreach($resDomainarr as $dm){
            $domain = explode("@",$dm->email);
            $emailDomainarr[]="@".$domain[1];
        }
        $data['emaildomains'] = array_unique($emailDomainarr);
        
        $data['team_member_id'] = $data['team_member_row']->user_id;
        $data['parent_child_unit'] = $parent_child_unit;
        return view('org_admin/add_team_member', $data);
    }

    public function update_team_member($id)
    {
        if ($this->request->getMethod() == 'post') {
            $p = $this->request->getPost();
            $db = db_connect();
            $checkEmailUser = "SELECT id FROM sq_user WHERE email = '{$p['email']}' AND trash_status <> 1 AND email <> '{$p['oldemail']}'";
            $resCheckEmailUser = $db->query($checkEmailUser);
            $rowEmailUser = $resCheckEmailUser->getRow();
            
            
            $checkExistUser = "SELECT ugcu.id FROM sq_user u 
                                LEFT JOIN
                                user_group_company_unit ugcu
                                ON ugcu.user_id=u.id
                                WHERE ugcu.id !=$id AND u.email = '{$p['email']}' AND u.trash_status <> 1 AND ugcu.group_id={$p['company_group_id']} AND ugcu.company_id={$p['company_id']} AND ugcu.unit_id={$p['unit_id']} AND ugcu.role_id={$p['role_id']}";
            //$checkExistUser = "SELECT id FROM user_group_company_unit WHERE id !=$id AND group_id={$p['company_group_id']} AND company_id={$p['company_id']} AND unit_id={$p['unit_id']} AND role_id={$p['role_id']}";
            //echo $checkExistUser;exit;
            //$checkExistUser = "SELECT id FROM sq_user WHERE id !=$id AND trash_status <> 1 AND company_group_id={$p['company_group_id']} AND company_id={$p['company_id']} AND unit_id={$p['unit_id']} AND role_id={$p['role_id']}";
            
            $resCheckExistUser = $db->query($checkExistUser);
            $rowExistUser = $resCheckExistUser->getRow();
            if (!empty($rowExistUser)) {
                session()->setFlashdata('message', 'User already exist');
                session()->setFlashdata('alert-class', 'alert-danger');

                $base_url = base_url('api/public/index.php/organization_admin/list_team_member');
                return redirect()->to($base_url);
            }
            
            
            if (empty($rowEmailUser)) {
                $email_str = strtolower($p['email']).$p['email_domain'];
                $sq_user_tbl = $db->table('sq_user');
                $sq_user_data = [
                    'username' => strtolower($p['name']),
                    'email' => $email_str,//strtolower($p['email']),
                    'full_name' => ucwords(strtolower($p['name'])),
                    'mobile' => $p['mobile_no'],
                    'company_group_id' => $p['company_group_id'],
                    'company_id' => $p['company_id'],
                    'unit_id' => $p['unit_id'],
                    'designation' => $p['designation'],
                    'role_id' => $p['role_id']
                ];
    
                $sq_user_tbl->where('id', $p['team_member_id']);
    
                if ($sq_user_tbl->update($sq_user_data)) {
                    $user_group_company_unit_tbl = $db->table('user_group_company_unit');
                    $user_group_company_unit_data = [
                        'group_id' => $p['company_group_id'],
                        'company_id' => $p['company_id'],
                        'unit_id' => $p['unit_id'],
                        'is_group_admin'=>0,
                        'is_company_admin'=>0,
                        'is_team_member'=>1,
                        'role_id'=>$p['role_id']
                    ];  
                    $user_group_company_unit_tbl->where('id', $id);
                    $user_group_company_unit_tbl->update($user_group_company_unit_data);
                    
                    session()->setFlashdata('message', 'Team Member updated successfully');
                    session()->setFlashdata('alert-class', 'alert-success');
    
                    $base_url = base_url('api/public/index.php/organization_admin/list_team_member');
                    return redirect()->to($base_url);
                } else {
    
                    session()->setFlashdata('message', 'Data not saved');
                    session()->setFlashdata('alert-class', 'alert-danger');
    
                    $base_url = base_url('api/public/index.php/organization_admin/list_team_member');
                    return redirect()->to($base_url);
                }
            }else {
                session()->setFlashdata('message', 'Data not saved');
                session()->setFlashdata('alert-class', 'alert-danger');

                $base_url = base_url('api/public/index.php/organization_admin/list_team_member');
                return redirect()->to($base_url);
            }
        }
    }

    public function delete_team_member()
    {

        $p = $this->request->getPost();

        $db = db_connect();

        $builder = $db->table('user_group_company_unit');
        $builder->set('trash_status', 1);
        $builder->where('id', $p['user_id']);

        if ($builder->update()) {
            echo json_encode(['status' => 'success', 'msg' => 'Record deleted successfully.', 'url' => base_url('api/public/index.php/organization_admin/list_team_member')]);
        } else {

            echo json_encode(['status' => 'error', 'msg' => 'Record not deleted.']);
        }
    }

    public function DT_Render_Columns($aColumns)
    {

        /* Paging */
        $dtLimit = "";
        if (isset($_GET['iDisplayStart']) && $_GET['iDisplayLength'] != '-1') {
            $dtLimit = "LIMIT " . stripslashes($_GET['iDisplayStart']) . ", " .
                stripslashes($_GET['iDisplayLength']);
        }
        $data['dtLimit'] = $dtLimit;


        /* Ordering */
        $dtOrder = '';
        if (isset($_GET['iSortCol_0'])) {
            $dtOrder = "ORDER BY  ";
            for ($i = 0; $i < intval($_GET['iSortingCols']); $i++) {
                if ($_GET['bSortable_' . intval($_GET['iSortCol_' . $i])] == "true") {
                    $dtOrder .= $aColumns[intval($_GET['iSortCol_' . $i])] . "
				 	" . stripslashes($_GET['sSortDir_' . $i]) . ", ";
                }
            }

            $dtOrder = substr_replace($dtOrder, "", -2);
            if ($dtOrder == "ORDER BY") {
                $dtOrder = "";
            }
        }
        $data['dtOrder'] = $dtOrder;


        /*
         * Filtering
         * NOTE this does not match the built-in DataTables filtering which does it
         * word by word on any field. It's possible to do here, but concerned about efficiency
         * on very large tables, and MySQL's regex functionality is very limited
         */

        $dtWhere = "";
        if (isset($_GET['sSearch']) && $_GET['sSearch'] != "") {
            $dtWhere = "WHERE (";
            for ($i = 0; $i < count($aColumns); $i++) {
                if (trim($aColumns[$i]) != '') {
                    $dtWhere .= $aColumns[$i] . " LIKE '%" . stripslashes($_GET['sSearch']) . "%' OR ";
                }
            }
            $dtWhere = substr_replace($dtWhere, "", -3);
            $dtWhere .= ')';
        }


        /* Individual column filtering */
        for ($i = 0; $i < count($aColumns); $i++) {
            if (trim($aColumns[$i]) != '') {
                if (isset($_GET['bSearchable_' . $i]) && $_GET['bSearchable_' . $i] == "true" && $_GET['sSearch_' . $i] != '') {
                    if ($dtWhere == "") {
                        $dtWhere = "WHERE ";
                    } else {
                        $dtWhere .= " AND ";
                    }
                    $dtWhere .= $aColumns[$i] . " LIKE '%" . stripslashes($_GET['sSearch_' . $i]) . "%' ";
                }
            }
        }

        $data['dtWhere'] = $dtWhere;

        $g = $this->request->getGet();

        // echo '<pre>';
        // print_r($g);
        // die;

        if (isset($g['company_group_id']) && !empty($g['company_group_id']) || isset($g['company_id']) && !empty($g['company_id']) || isset($g['unit_id']) && !empty($g['unit_id'])) {
            $group_id = '';
            if (isset($g['company_group_id']) && !empty($g['company_group_id'])) {
                $group_id = " ugc.group_id = '{$g['company_group_id']}'";
            }

            $company_id = '';
            if (isset($g['company_id']) && !empty($g['company_id'])) {
                $company_id = " (ugc.company_id = '{$g['company_id']}' OR (r.id = 1 AND u.company_id = 0))";
            }

            $unit_id = '';
            if (
                isset($g['unit_id']) && !empty($g['unit_id'])
            ) {
                $unit_id = " (ugc.unit_id = '{$g['unit_id']}' OR un.parent_unit_id = '{$g['unit_id']}')";
            }

            if (!empty($group_id)) {
                $clauses[] = $group_id;
            }

            if (!empty($company_id)) {
                $clauses[] = $company_id;
            }

            if (!empty($unit_id)) {
                $clauses[] = $unit_id;
            }

            $clauses = array_filter($clauses);

            $dtWhere = !empty($clauses) ? ' AND ' . implode(' AND ', $clauses) : '';

            $data['dtWhere'] = $dtWhere;
        }
        // var_dump($dtWhere);
        return $data;
    }
    
    
    function get_email_user_detail(){
        $g = $this->request->getGet();
        $rdata['mobile'] = '';
        $rdata['full_name'] = '';
        $rdata['status'] = '';
        if (!empty($g['email'])) {
            $db = db_connect();
            // echo
                $checkEmail = "SELECT id,email,full_name,mobile
                            FROM sq_user
                            WHERE email = '{$g['email']}' 
                            AND trash_status <> 1 
                        ";
            // die;
            $resCheckEmail = $db->query($checkEmail);
            $rowEmail = $resCheckEmail->getRow();
            //echo "<pre>";print_r($rowEmail);exit;
            if(!empty($rowEmail)){
                $rdata['mobile'] = $rowEmail->mobile;
                $rdata['full_name'] = $rowEmail->full_name;
                $rdata['status'] = 'success';
            }
        }
        echo json_encode($rdata);
    }
    function get_parent_user_authority($uid){
        $db = db_connect();
        // echo
        $UserDet = "SELECT id,sup_org_admin_id,is_sup_org_admin,no_of_seek_feedback_allowed,sq_detailed_assessment
                    FROM sq_user
                    WHERE id = '{$uid}' 
                    AND trash_status <> 1 
                ";
        // die;
        $resUserDet = $db->query($UserDet);
        $rowUserDet = $resUserDet->getRow();
        return $rowUserDet;
    }
    function get_company_admin_id($cmpid){
        $db = db_connect();
        // echo
        $compdata = "SELECT id,user_id
                    FROM user_group_company_unit
                    WHERE company_id = '{$cmpid}' AND is_company_admin=1 
                    AND trash_status <> 1 
                ";
        // die;
        $resdata = $db->query($compdata);
        $rowdata = $resdata->getRow();
        return $rowdata;
    }
    function get_grp_admin_id($grp_id){
        $db = db_connect();
        // echo
        $grpdata = "SELECT id,user_id
                    FROM user_group_company_unit
                    WHERE group_id = '{$grp_id}' AND is_group_admin=1 
                    AND trash_status <> 1 
                ";
        // die;
        $resdata = $db->query($grpdata);
        $rowdata = $resdata->getRow();
        return $rowdata;
    }
    
    function check_user_exist_another_org($email){
        $authority_data = $this->get_parent_user_authority($_SESSION['uid']);
        if(!empty($authority_data)){
            $no_of_seek_feedback_allowed = $authority_data->no_of_seek_feedback_allowed;
            $sq_detailed_assessment = $authority_data->sq_detailed_assessment;
            $sup_org_admin_id = $authority_data->sup_org_admin_id;
        }else{
            $no_of_seek_feedback_allowed = 0;
            $sq_detailed_assessment = 0;
            $sup_org_admin_id = 0;
        }
        $sup_org_admin = (isset($_SESSION['is_sup_org_admin'])==1 ? $_SESSION['uid'] : $sup_org_admin_id);
        $db = db_connect();
        // echo
        $grpdata = "SELECT id
                    FROM sq_user
                    WHERE email = '{$email}' AND sup_org_admin_id != '{$sup_org_admin}' 
                    AND trash_status <> 1 
                ";
        // die;
        $resdata = $db->query($grpdata);
        $rowdata = $resdata->getRow();
        return $rowdata;
    }
    
}
